var baseURL = "https://logmyhours.com/api/v1/";
// var baseURL = "https://dev.lmh.192.168.1.74.xip.io/api/v1/";
// var baseURL = "https://dev.logmyhours.com/api/v1/";

var availableLanguages = ['en', 'zh', 'ja'];
var defaultLanguage = 'en';
var appVersion = "0.0.0";
var locale = "en";

var refresh = false;

var app = angular.module('starter', ['ionic', 'ionic.service.core', 'starter.controllers', 'angular-storage', 'angular-jwt', 'angularMoment', 'ngCordova',
    'LocalStorageModule', 'http-auth-interceptor', 'chart.js', 'angular.filter', 'ngAnimate', 'ngStorage', 'nl2br', 'ionic-datepicker', 'ionic-timepicker',
    'ng-currency', 'ngSanitize', 'ngMessages', 'ui.utils.masks', 'pascalprecht.translate', 'tmh.dynamicLocale', 'ionic-color-picker'])

    .constant('availableLanguages', ['en', 'zh', 'ja'])
    .constant('defaultLanguage', 'en')

    .run(function ($ionicPlatform, $http, UserService, QuickActionService, tmhDynamicLocale, $cordovaGlobalization, $translate,
                   $rootScope) {

        function applyLanguage(language) {
            tmhDynamicLocale.set(language.toLowerCase());
            locale = language.toLowerCase();
        }

        function getSuitableLanguage(language) {
            for (var index = 0; index < availableLanguages.length; index++) {
                if (availableLanguages[index].toLowerCase() === language.toLocaleLowerCase()) {
                    return availableLanguages[index];
                }
            }
            return defaultLanguage;
        }

        function setLanguage() {
            if (typeof navigator.globalization !== "undefined") {
                $cordovaGlobalization.getPreferredLanguage().then(function (result) {
                    var language = getSuitableLanguage((result.value).substr(0, 2));

                    applyLanguage(language);
                    $translate.use(language);
                });
            } else {
                applyLanguage('en');
            }
        }

        $ionicPlatform.ready(function () {
            setLanguage();

            QuickActionService.configure('play');

            // Setting app verison
            if (window.cordova) {
                cordova.getAppVersion(function (version) {
                    appVersion = version;
                });
            }

            // Not working in ionic 1.3
            // https://github.com/shprink/ionic-native-transitions
            // https://github.com/shprink/ionic-native-transitions/issues/97 -- looks fixed now
            // $ionicNativeTransitions.enable(false);

            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)

            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false); //ionic removed - app store no like
                cordova.plugins.Keyboard.disableScroll(true);

            }

            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleDefault();
            }

            // Google Analytics
            if (typeof window.analytics !== 'undefined') {
                console.dir('google analytics');
                window.analytics.startTrackerWithId('UA-20257410-13');
                window.analytics.trackView('init')

                console.dir('state changed');
                $rootScope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {

                    if (toState.name != 'app.admin.all') {
                        window.analytics.trackView(toState.name)
                    }
                });
            }


            // Check to see if user is still logged in.
            // $ionicPlatform.on('resume', function () {
            //     console.dir('app reopened 1');
            //     // not logged in
            //     if (!UserService.getUser()) return;
            //
            //     $http({
            //         method: 'get',
            //         async: false,
            //         url: baseURL + 'account/view',
            //
            //     }).success(function (data) {
            //         console.dir('success still logged in');
            //     }).error(function (data) {
            //         console.dir('error');
            //     });
            //
            // });

        });
    })

    .config(function (tmhDynamicLocaleProvider, $translateProvider, defaultLanguage) {
        tmhDynamicLocaleProvider.localeLocationPattern('lib/angular-i18n/angular-locale_{{locale}}.js');

        $translateProvider.useStaticFilesLoader({
            'prefix': 'js/i18n/',
            'suffix': '.json'
        });
        $translateProvider.preferredLanguage(defaultLanguage);
        $translateProvider.useSanitizeValueStrategy('escapeParameters');

    })

    .factory('timeoutHttpIntercept', function ($rootScope, $q) {
        return {
            'request': function (config) {
                config.timeout = 15000; // 15 second timeout
                return config;
            }
        }})

    .config(['$httpProvider', 'localStorageServiceProvider', function ($httpProvider) {

        $httpProvider.defaults.useXDomain = true;
        $httpProvider.defaults.headers.common = 'Content-Type: application/json';

        delete $httpProvider.defaults.headers.common['X-Requested-With'];

        $httpProvider.interceptors.push('authInterceptorService');
        $httpProvider.interceptors.push('timeoutHttpIntercept');
    }])


    // tabs at bottom - we dont use the learnquiq tabs
    // .config(['$ionicConfigProvider', function ($ionicConfigProvider) {

        // Native Scrolling
        // $ionicConfigProvider.scrolling.jsScrolling(false);
        // $ionicConfigProvider.tabs.position('bottom'); // other values: top
    // }])

    .config(function ($stateProvider, $urlRouterProvider) {
        $stateProvider

            .state('account', {
                cache: false,
                url: '/auth',
                templateUrl: 'templates/home.html',
                controller: 'AuthCtrl'
            })
            .state('account-login', {

                url: '/auth/login',
                templateUrl: 'templates/auth/login.html',
                controller: 'AuthCtrl'

            })

            .state('account-register', {

                url: '/account/register',
                templateUrl: 'templates/auth/register.html',
                controller: 'AuthCtrl'

            })

            .state('welcome', {
                url: "/welcome",
                abstract: true,
                templateUrl: "templates/welcome/index.html",
                controller: 'WelcomeCtrl'

            })

            .state('welcome.intro', {
                url: "/intro",
                views: {
                    'welcome': {
                        templateUrl: "templates/welcome/welcome.html",
                    }
                }
            })

            .state('welcome.profile', {
                url: "/profile",
                views: {
                    'welcome': {
                        templateUrl: "templates/welcome/profile.html",
                    }
                }
            })

            .state('welcome.company', {
                url: "/company",
                views: {
                    'welcome': {
                        templateUrl: "templates/welcome/company.html",
                    }
                }
            })

            .state('welcome.project', {
                url: "/project",
                views: {
                    'welcome': {
                        templateUrl: "templates/welcome/project.html",
                    }
                }
            })

            .state('welcome.finished', {
                url: "/info",
                views: {
                    'welcome': {
                        templateUrl: "templates/welcome/finished.html",
                    }
                }
            })


            .state('app', {
                cache: false,
                url: '/app',
                nativeTransitions: null,
                abstract: true,
                templateUrl: 'templates/menu.html',
                controller: 'AccountCtrl'
            })

            .state('app.admin', {
                url: '/admin',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/admin/index.html',
                        controller: 'AdminCtrl'
                    }
                }
            })

            .state('app.admin.all', {
                url: '/all',
                views: {
                    'users': {
                        templateUrl: 'templates/admin/all.html',
                    }
                }
            })
            .state('app.admin.members', {
                url: '/members',
                views: {
                    'users': {
                        templateUrl: 'templates/admin/members.html',
                    }
                }
            })
            .state('app.admin.prospects', {
                url: '/prospects',
                views: {
                    'users': {
                        templateUrl: 'templates/admin/prospects.html',
                    }
                }
            })

            .state('app.account', {

                url: '/account',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/account/index.html',
                        controller: 'AccountCtrl'
                    }
                }


            })

            .state('app.account-settings', {
                url: '/account/settings',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/account/settings.html',
                        controller: 'AccountCtrl'
                    }
                }
            })

            .state('app.news', {
                url: '/news',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/news/index.html',
                        controller: 'AccountCtrl'
                    }
                }
            })


            .state('app.company', {
                url: '/company',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/company/index.html',
                        controller: 'CompanyCtrl'
                    }
                }
            })

            .state('app.company-edit', {
                url: '/company/edit/:company_id',
                templateUrl: 'templates/company/edit.html',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/company/edit.html',
                        controller: 'CompanyEditCtrl'
                    }
                }
            })

            .state('app.company.active', {
                url: '/active',
                views: {
                    'companies': {
                        templateUrl: 'templates/company/active.html',
                    }
                }
            })
            .state('app.company.archived', {
                url: '/archived',
                views: {
                    'companies': {
                        templateUrl: 'templates/company/archived.html',
                    }
                }
            })


            .state('app.client', {
                url: '/client',
                // cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'templates/client/index.html',
                        controller: 'ClientCtrl'
                    }
                }
            })

            .state('app.client.active', {
                url: '/active',
                views: {
                    'clients': {
                        templateUrl: 'templates/client/active.html',
                    }
                }
            })
            .state('app.client.archived', {
                url: '/archived',
                views: {
                    'clients': {
                        templateUrl: 'templates/client/archived.html',
                    }
                }
            })


            .state('app.client-edit', {
                url: '/client/edit/:client_id',
                templateUrl: 'templates/client/edit.html',

                views: {
                    'menuContent': {
                        templateUrl: 'templates/client/edit.html',
                        controller: 'ClientEditCtrl'
                    }
                }
            })

            .state('app.timesheet', {
                //cache: false,
                url: '/timesheet/:option',
                params: {
                    option: {value: null, squash: true}
                },
                views: {
                    'menuContent': {
                        templateUrl: 'templates/timesheet/index.html',
                        controller: 'TimesheetCtrl'
                    }
                }
            })

            .state('app.timesheet-new', {
                url: '/timesheet/edit/:timesheet_id',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/timesheet/edit.html',
                        controller: 'TimesheetEditCtrl'
                    }
                }
            })

            .state('app.timesheet-quick', {
                url: '/timesheet/quick/:timesheet_id',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/timesheet/quick.html',
                        controller: 'TimesheetEditCtrl'
                    }
                }
            })

            .state('app.timesheet-edit', {
                //abstract: true,
                url: '/timesheet/edit/:date/:timesheet_id',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/timesheet/edit.html',
                        controller: 'TimesheetEditCtrl'
                    }
                }
            })

            .state('app.timesheet-month', {
                url: '/timesheet/date/:date',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/timesheet/month.html',
                        controller: 'TimesheetMonthCtrl'
                    }
                }
            })

            .state('app.invoice', {
                url: '/invoice',
                // abstract: true,
                views: {
                    'menuContent': {
                        templateUrl: 'templates/invoice/index.html',
                        controller: 'InvoiceCtrl'
                    }
                }
            })

            .state('app.invoice.active', {
                url: '/active',
                views: {
                    'invoices': {
                        templateUrl: 'templates/invoice/active.html',
                    }
                }
            })
            .state('app.invoice.archived', {
                url: '/archived',
                views: {
                    'invoices': {
                        templateUrl: 'templates/invoice/archived.html',
                    }
                }
            })


            .state('app.invoice-edit', {
                url: '/invoice/edit/:invoice_id',
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'templates/invoice/edit.html',
                        controller: 'InvoiceEditCtrl'
                    }
                }
            })

            .state('app.invoice-edit.items', {
                url: '/items',
                views: {
                    'invoice-edit': {
                        templateUrl: 'templates/invoice/edit-items.html',
                    }
                }
            })
            .state('app.invoice-edit.options', {
                url: '/options',
                views: {
                    'invoice-edit': {
                        templateUrl: 'templates/invoice/edit-options.html',
                    }
                }
            })

            .state('app.invoice-edit.preview', {
                url: '/preview',
                views: {
                    'invoice-edit': {
                        templateUrl: 'templates/invoice/edit-preview.html',
                    }
                }
            })
            .state('app.invoice-edit.mail', {
                url: '/mail',
                views: {
                    'invoice-edit': {
                        templateUrl: 'templates/invoice/edit-mail.html',
                    }
                }
            })

            .state('app.employee', {
                url: '/employee',
                // abstract: true,
                views: {
                    'menuContent': {
                        templateUrl: 'templates/employee/index.html',
                        controller: 'EmployeeCtrl'
                    }
                }
            })

            .state('app.employee.active', {
                url: '/active',
                views: {
                    'employees': {
                        templateUrl: 'templates/employee/active.html',
                    }
                }
            })
            .state('app.employee.archived', {
                url: '/archived',
                views: {
                    'employees': {
                        templateUrl: 'templates/employee/archived.html',
                    }
                }
            })
            .state('app.employee-edit', {
                url: '/employee/edit/:employee_id',
                templateUrl: 'templates/employee/edit.html',

                views: {
                    'menuContent': {
                        templateUrl: 'templates/employee/edit.html',
                        controller: 'EmployeeEditCtrl'
                    }
                }
            })

            .state('app.expense', {
                url: '/expense',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/expense/index.html',
                        controller: 'ExpenseCtrl'
                    }
                }
            })
            .state('app.expense-edit', {
                url: '/expense/edit/:expense_id/:option',
                params: {
                    option: {value: null, squash: true}
                },
                views: {
                    'menuContent': {
                        templateUrl: 'templates/expense/edit.html',
                        controller: 'ExpenseEditCtrl'
                    }
                }
            })

            .state('app.project', {
                url: '/project',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/project/index.html',
                        controller: 'ProjectCtrl'
                    }
                }
            })

            .state('app.project.active', {
                url: '/active',
                views: {
                    'projects': {
                        templateUrl: 'templates/project/active.html',
                    }
                }
            })
            .state('app.project.archived', {
                url: '/archived',
                views: {
                    'projects': {
                        templateUrl: 'templates/project/archived.html',
                    }
                }
            })


            .state('app.project-edit', {
                url: '/project/edit/:project_id',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/project/edit.html',
                        controller: 'ProjectEditCtrl'
                    }
                }
            })

            .state('app.dashboard', {
                url: '/dashboard',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/dashboard/index.html',
                        controller: 'DashboardCtrl'
                    }
                }
            })

            .state('app.report', {
                url: '/report',
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'templates/report/index.html',
                        controller: 'ReportCtrl'
                    }
                }
            })
            // .state('app.report.preview', {
            //     url: '/preview',
            //     templateUrl: 'templates/report/preview.html',
            //     views: {
            //         'menuContent': {
            //             templateUrl: 'templates/company/edit.html',
            //         }
            //     }
            // })


            .state('app.feedback', {
                url: '/feedback',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/feedback/index.html',
                        controller: 'AccountCtrl'
                    }
                }
            })
            .state('app.help', {
                url: '/help',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/help/index.html',
                        controller: 'HelpCtrl'
                    }
                }
            })


        ;
        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/auth');
    });


app.config(function (localStorageServiceProvider) {
    console.dir('storage provider');
    localStorageServiceProvider
        .setPrefix('starter');
});

'use strict';
app.factory('authInterceptorService',
    function ($q, $injector, localStorageService, authService, $localStorage) {

        var authInterceptorServiceFactory = {};

        var _request = function (config) {
            //localStorageService.clearAll();
            config.headers = config.headers || {};
            //console.dir(config.headers.Authorization);

            var authData = localStorageService.get('authorizationData');
            if (authData) {
                config.headers.Authorization = 'Bearer ' + authData.token;
            }

            return config;
        };

        var refreshToken = function () {


            var idToken = $localStorage.token;

            var refreshToken = $localStorage.refreshToken;

            console.dir('refresh token: ' + refreshToken);

            if (refreshToken) {
                console.dir('attempting to refresh token');
                var refresh = baseURL + 'authorize/refresh';

                var refreshToken = {
                    refreshToken: refreshToken,
                };

                //console.dir(rejection.config);


                // Clear header
                localStorageService.clearAll();
                var $http = $injector.get('$http');

                return $http({
                    method: 'post',
                    url: refresh,
                    data: refreshToken,
                }).success(function (data2) {
                    console.dir('refresh success: ');
                    console.dir(data2);

                    $localStorage.token = data2['token']['access_token'];
                    $localStorage.refreshToken = data2['token']['refresh_token'];
                    localStorageService.set('authorizationData', {token: data2['token']['access_token']});

                    return true;
                    //return $http(rejection.config);

                }).error(function (data, status, headers, config) {
                    return false;
                });


            } else {

                console.dir('no refresh token - shouldnt get here');
                $localStorage.$reset();

                localStorageService.clearAll();
                return $q.reject(rejection);


                //return function(){
                //    return $q.reject(rejection);
                //};
            }

        };

        var _responseError = function (rejection) {
            console.dir('auth rejected');
            console.dir(rejection);


            if (rejection.status === 401) {
                var token = $localStorage.refreshToken;
                console.dir($localStorage);

                if (!token) {
                    console.dir('no refresh token2');
                    $localStorage.$reset();
                    localStorageService.clearAll();
                    var $ionicLoading = $injector.get('$ionicLoading');
                    $ionicLoading.hide();

                    // Todo - need to clear popup
                    // $ionicLoading.hide();


                    $injector.get('$state').transitionTo('account');
                    return $q.reject(rejection);
                }

                return refreshToken().then(function (result) {
                    console.dir('promise test2');
                    console.dir(result);
                    console.dir($localStorage);

                    if (result) {
                        console.dir('refresh true');
                        var $http = $injector.get('$http');

                        return $http(rejection.config);
                    } else {
                        console.dir('refresh false');
                        localStorageService.clearAll();
                        $localStorage.$reset();

                        var $ionicLoading = $injector.get('$ionicLoading');
                        $ionicLoading.hide();

                        $injector.get('$state').transitionTo('account');
                        return $q.reject(rejection);

                    }

                });

            } else if (rejection.status === 403) {
                var $ionicPopup = $injector.get('$ionicPopup');
                var $ionicLoading = $injector.get('$ionicLoading');
                var message = rejection.data.message || "Not Allowed.";

                message = rejection.data.error.exception[0].message  || message;

                $ionicPopup.alert({
                    title: 'Denied',
                    template: message,
                });

                $ionicLoading.hide();
            } else if (rejection.status === 500) {
                var $ionicPopup = $injector.get('$ionicPopup');
                var $ionicLoading = $injector.get('$ionicLoading');
                $ionicPopup.alert({
                    title: 'Internal Server Error. The devs have been notified.',
                });

                $ionicLoading.hide();

            } else if (rejection.status === 501) {
                var $ionicPopup = $injector.get('$ionicPopup');
                var $ionicLoading = $injector.get('$ionicLoading');

                var message = rejection.data.message || "Server Error.";

                $ionicPopup.alert({
                    title: message,
                });

                $ionicLoading.hide();


            } else if (rejection.status === 404) {

                console.log('404');
                console.log(rejection);
                console.log(rejection.data);
                console.log(rejection.data.message);

                var message = rejection.data.message || "Couldn't find item. Try refreshing.";

                var $ionicPopup = $injector.get('$ionicPopup');
                $ionicPopup.alert({
                    title: '404 Error',
                    template: message,
                });

            } else if (rejection.status === -1) {

                var $ionicPopup = $injector.get('$ionicPopup');
                $ionicPopup.alert({
                    title: 'Couldn\'t connect to the server',
                });

                var $ionicLoading = $injector.get('$ionicLoading');
                $ionicLoading.hide();

            } else if (rejection.status === 401) {
                console.dir(rejection.status);
                // return $q.reject(rejection);

            } else {


                var $ionicLoading = $injector.get('$ionicLoading');
                $ionicLoading.hide();
                console.dir(rejection.status);
                console.dir('Internal Server Error');
                return $q.reject(rejection);
            }

            console.dir('nope');
            return $q.reject(rejection);

        };

        authInterceptorServiceFactory.request = _request;
        authInterceptorServiceFactory.responseError = _responseError;

        return authInterceptorServiceFactory;
    });




app.directive('ngMin', function () {
    return {
        restrict: 'A',
        require: 'ngModel',
        link: function (scope, elem, attr, ctrl) {
            scope.$watch(attr.ngMin, function () {
                ctrl.$setViewValue(ctrl.$viewValue);
            });
            var minValidator = function (value) {
                var min = scope.$eval(attr.ngMin) || 0;
                if (!isEmpty(value) && value < min) {
                    ctrl.$setValidity('ngMin', false);
                    return undefined;
                } else {
                    ctrl.$setValidity('ngMin', true);
                    return value;
                }
            };

            ctrl.$parsers.push(minValidator);
            ctrl.$formatters.push(minValidator);
        }
    };
});

app.directive('ngMax', function () {
    return {
        restrict: 'A',
        require: 'ngModel',
        link: function (scope, elem, attr, ctrl) {
            scope.$watch(attr.ngMax, function () {
                ctrl.$setViewValue(ctrl.$viewValue);
            });
            var maxValidator = function (value) {
                var max = scope.$eval(attr.ngMax) || Infinity;
                if (!isEmpty(value) && value > max) {
                    ctrl.$setValidity('ngMax', false);
                    return undefined;
                } else {
                    ctrl.$setValidity('ngMax', true);
                    return value;
                }
            };

            ctrl.$parsers.push(maxValidator);
            ctrl.$formatters.push(maxValidator);
        }
    };
});

// app.config(function(tagsInputConfigProvider) {
//     tagsInputConfigProvider
//         .setDefaults('tagsInput', {
//             placeholder: 'New tags',
//             // minLength: 5,
//             // addOnEnter: false
//         })
//         .setDefaults('autoComplete', {
//             debounceDelay: 400,
//             // loadOnDownArrow: true,
//             // loadOnEmpty: true
//         })
// });
