app.controller('ClientCtrl', function ($scope, $stateParams, $http, $state, store, UserService) {
    console.dir('client controller');
    $scope.clients = UserService.getClients();
    // $scope.companies = UserService.getCompanies();

    console.dir($scope.clients);

    $scope.$on('reloaded', function (event, data) {
        $scope.clients = UserService.getClients();
    });


    $scope.refresh = function () {
        var route = 'client'

        $http({
            method: 'get',
            url: baseURL + route,

        }).success(function (data) {
            console.dir(data);

            console.dir('getting clients success');
            $scope.clients = data['clients'];

            UserService.setClients(data['clients']);

            $scope.$broadcast('scroll.refreshComplete');
        }).error(function (data, status, headers, config) {
            console.dir('getting clients error');
            $scope.$broadcast('scroll.refreshComplete');
        });
    }

    $scope.archiveClient = function (client) {
        var route = 'client/archive';

        $http({
            method: 'post',
            url: baseURL + route,
            data: {'client_id': client.id},

        }).success(function (data) {
            console.dir(data);

            if (data['status'] == 'success') {
                console.dir('archive toggle client - success');


                client = data.client;

                $('#client-'+client.id).slideUp("normal", function() {
                    UserService.setClient(data.client);
                });



            } else {
                console.dir('archive client - success but error');
            }

        }).error(function (data) {
            console.dir('archive client - error');
            console.dir(data);
        });

    }

})

app.controller('ClientEditCtrl', function ($scope, $stateParams, $http, $ionicHistory, UserService, $ionicPopup, $ionicLoading) {
    console.dir('client edit controller');
    var client_id = $stateParams.client_id;


    $scope.client = UserService.getClient(client_id);

    if (!$scope.client) {
        $scope.client = [
            'name', 'contact_name', 'email'
        ];
    }

    console.dir($scope.client);

    $scope.updateClient = function (form) {

        console.dir($scope.client);
        if (!form.$valid) {
            return false;
        }
        

        var data = {
            client: {
                name: $scope.client.name,
                contact_name: $scope.client.contact_name,
                email: $scope.client.email,
                id: $scope.client.id,
                color: ($scope.client.color) ? $scope.client.color : '#90EE90'
            }
        };

        $ionicLoading.show({
            template: '<ion-spinner class="light"></ion-spinner><br />Saving...',
            content: '',
        });

        var route = 'client/edit';
        $http({
            method: 'post',
            url: baseURL + route,
            data: data,

        }).success(function (data) {
            console.dir(data);

            if (data['status'] == 'success') {
                console.dir('edit client - success');

                UserService.setClient(data.client);

                $ionicPopup.alert({
                    title: 'Client Saved!',
                });

                $ionicHistory.goBack();

            } else {
                console.dir('edit client - success but error');
            }

        }).error(function (data) {
            console.dir('edit client - error');
            console.dir(data);
        }).then(function () {
            $ionicLoading.hide();
        });
    };

})