app.controller('CompanyCtrl', function ($scope, $stateParams, $http, $state, UserService, $ionicPopup) {
    console.dir('company controller');

    // $scope.clients = UserService.getClients();
    $scope.companies = UserService.getCompanies();
    $scope.user = UserService.getUser();
    console.dir($scope.companies);

    $scope.$on('reloaded', function (event, data) {
        $scope.companies = UserService.getCompanies();
    });

    $scope.refresh = function () {
        var route = 'company';

        $http({
            method: 'get',
            url: baseURL + route,

        }).success(function (data) {
            console.dir(data);

            console.dir('getting companies success');
            $scope.companies = data['companies'];
            UserService.setCompanies($scope.companies);

            $scope.$broadcast('scroll.refreshComplete');
        }).error(function (data, status, headers, config) {
            console.dir('getting companies error');
            $scope.$broadcast('scroll.refreshComplete');
        });
    }

    $scope.archiveCompany = function (company) {
        var route = 'company/archive';

        $http({
            method: 'post',
            url: baseURL + route,
            data: {'company_id': company.id},

        }).success(function (data) {
            console.dir(data);

            if (data['status'] == 'success') {
                console.dir('archive toggle company - success');

                company = data.company;

                $('#company-'+company.id).slideUp("normal", function() {
                    UserService.setCompany(data.company);
                });


            } else {
                console.dir('archive company - success but error');
            }

        }).error(function (data) {
            console.dir('archive company - error');
            console.dir(data);
        });

    }

    $scope.deleteCompany = function (company) {
        var route = 'company/delete';

        $http({
            method: 'post',
            url: baseURL + route,
            data: {'company_id': company.id},

        }).success(function (data) {
            console.dir(data);

            if (data['status'] == 'success') {
                console.dir('delete company - success');

                //UserService.setCompany(data.company);
                delete company;


            } else {
                console.dir('delete company - success but error');
            }

        }).error(function (data) {
            console.dir('delete company - error');
            console.dir(data);
        });
    }
})

app.controller('CompanyEditCtrl', function ($scope, $stateParams, $http, $ionicPopup, $ionicHistory, UserService, $window, Utils,
                                            $ionicActionSheet, $cordovaFileTransfer, localStorageService, $ionicLoading) {
    console.dir('company edit controller');
    var company_id = $stateParams.company_id;

    //$scope.company = angular.copy($scope.data.companies[company_id]);
    $scope.company = UserService.getCompany(company_id);
    $scope.image_file = null;
    console.dir(company_id);
    console.dir($scope.company);

    if (!$scope.company) {
        $scope.company = [
            'name', 'contact_name', 'email'
        ];
    }

    $scope.upload = function (files) {
        console.dir('setting file');
        console.dir(files);
        var options = {
            mimeType: files[0].type,
            fileName: files[0].name
        }

        $scope.image_file = cordova.file.tempDirectory + files[0].name;

        console.dir(files[0].name);
        console.dir(cordova.file);

        $scope.image1 = cordova.file.externalDataDirectory + files[0].name
        $scope.image2 = cordova.file.applicationStorageDirectory + files[0].name
        $scope.image3 = cordova.file.cacheDirectory + files[0].name
        $scope.image4 = cordova.file.tempDirectory + files[0].name
        $scope.image5 = cordova.file.applicationDirectory + files[0].name

        $scope.$apply();

        $window.resolveLocalFileSystemURL(files[0].name, function (fileEntry) {

            realURL = fileEntry.nativeURL;

            console.dir(fileEntry);
            console.dir(realURL);

        }, function (error) {
            console.dir(error)
        });

    }


    $scope.updateCompany = function (form) {

        if (!form.$valid) {
            return false;
        }

        var data = {
            company: {
                name: $scope.company.name,
                contact_name: $scope.company.contact_name,
                email: $scope.company.email,
                id: $scope.company.id,
                gstNumber: $scope.company.gst_number,
                color: ($scope.company.color) ? $scope.company.color : '#90EE90'
            }
        };

        var route = 'company/edit';

        if ($scope.company.new_image) {

            $ionicLoading.show({
                template: '<ion-spinner class="light"></ion-spinner><br />Uploading...',
                content: '',
            });

            var options = new FileUploadOptions();
            options.fileKey = "file";
            options.fileName = 'logo.jpg';
            options.mimeType = "image/jpg";
            options.chunkedMode = false;
            options.params = data.company;

            options.headers = {Authorization: 'Bearer ' + localStorageService.get('authorizationData').token}
            console.dir('upload start');

            $cordovaFileTransfer.upload(baseURL + route, $scope.company.new_image, options, true).then(function (result) {
                    console.dir('logo uploaded');
                    result = JSON.parse(result.response);
                    console.log("SUCCESS: " + JSON.stringify(result.response));

                    console.dir(result);
                    console.dir(result.status);

                    UserService.setCompany(result.company);


                    $ionicLoading.hide();
                    $ionicHistory.goBack();
                    $ionicPopup.alert({
                        title: 'Company Saved!',
                    });


                }, function (err) {
                    $ionicLoading.hide();

                    console.log("ERROR1");
                    console.log("ERROR: " + JSON.stringify(err));
                    console.log(JSON.stringify(err.response));
                    console.log(err);

                    $ionicPopup.alert({
                        title: 'Error uploading',
                    });
                }
            );
        } else {

            $ionicLoading.show({
                template: '<ion-spinner class="light"></ion-spinner><br />Saving...',
                content: '',
            });

            $http({
                method: 'post',
                url: baseURL + route,
                data: data,

            }).success(function (data) {
                console.dir(data);

                if (data['status'] == 'success') {
                    console.dir('edit company - success');

                    // UserService.setCompany(data.company);
                    UserService.setCompany(data.company);

                    $ionicPopup.alert({
                        title: 'Company Saved!',
                    });
                    $ionicHistory.goBack();


                } else {
                    console.dir('edit company - success but error');
                }

            }).error(function (data) {
                console.dir('edit company - error');
                console.dir(data);
            }).then(function() {
                $ionicLoading.hide();
            });
        }

    };

    $scope.updateLogo = function () {

        // Dropbox not working
        if (!$scope.company.new_image && !$scope.company.logo) {
            // companyImage(0);
            // return;
            var buttons = [
                {text: 'Photo Library'},
                {text: 'Dropbox'},
            ]
        } else if (!$scope.company.new_image) {
            var buttons = [
                // {text: 'Photo Library'},
                {text: 'Dropbox'},
                {text: 'Remove Current Logo'},
            ]
        } else {
            var buttons = [
                {text: 'Photo Library'},
                {text: 'Dropbox'},
                {text: 'Remove New Logo'},
            ]
        }

        // Show the action sheet
        var hideSheet = $ionicActionSheet.show({

            buttons: buttons,
            titleText: 'Update Logo',
            cancelText: 'Cancel',
            cancel: function () {
                // add cancel code..
            },
            buttonClicked: function (index) {
                console.dir(index);
                if (index == 0)  companyImage(0);
                if (index == 1)  openChooser();
                if (index == 2) {

                    if ($scope.company.logo) {
                        var route = "company/"+$scope.company.id+'/logo';

                        $http({
                            method: 'delete',
                            url: baseURL + route,

                        }).success(function (data) {
                            console.dir(data);

                            if (data['status'] == 'success') {
                                console.dir('delete company logo - success');


                                // Using temp incase user changed forms but didnt save company info.
                                var temp =  UserService.getCompany($scope.company.id);
                                $scope.company.logo = null;
                                $scope.company.image_link = null;
                                UserService.setCompany(temp);


                                $ionicPopup.alert({
                                    title: 'Company logo has been deleted',
                                });


                            } else {
                                console.dir('edit company - success but error');
                            }

                        }).error(function (data) {
                            console.dir('edit company - error');
                            console.dir(data);
                        });


                    }


                    $scope.company.new_image = null;

                }
                return true;
            }
        });

        var companyImage = function (mode) {
            //$scope.image = document.getElementById('myImage');
            //if (navigator.camera) {
            console.dir('video from library');

            var source = (mode == 'library') ? navigator.camera.PictureSourceType.PHOTOLIBRARY : navigator.camera.PictureSourceType.CAMERA;

            var options = {
                sourceType: mode,
                mediaType: navigator.camera.MediaType.PICTURE,
                correctOrientation: true,
                encodingType: Camera.EncodingType.JPEG,
                quality: 75,
                allowEdit: true,
                targetWidth: 720,
            };
            console.dir(options);

            navigator.camera.getPicture(function (photoData) {

                console.dir('photo success');
                console.dir(photoData);


                $scope.company.new_image = photoData;
                $scope.$apply();

            }, function (err) {
                console.dir(err);
            }, options);

        };
    }

    var openChooser = function () {
        // Instantiate the DropboxChooser object first.
        var DropboxChooser = window.plugins.DropboxChooser;

        // If this plugin is running on an Android device,
        // the Dropbox app key needs feeding into the class.
        // For iOS, this is not necessary
        if (ionic.Platform.isAndroid()) {
            DropboxChooser.init('YOUR_DROPBOX_APPID');
        }

        console.dir('chooser');
        console.dir(DropboxChooser);

        // Call the method 'launchDropboxChooser', which has 3 args:
        // success callback, failure callback and a mandatory
        // flag to specify if you want a 'Preview' link returned
        // ( "true" for a 'Preview' link; "false" for a 'Direct' link).
        DropboxChooser.launchDropboxChooser(dropboxSuccess, dropboxError, "true");

        function dropboxSuccess(results) {
            console.dir('db success');

            $ionicLoading.show({
                template: '<ion-spinner class="light"></ion-spinner><br />Loading...',
                content: '',
            });


            var selectedFile = results.pop();

            console.dir(selectedFile);

            var uri = encodeURI(selectedFile.link + '&raw=1');


            Utils.isImage(uri).then(function (result) {

                if (result == false) {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: 'Not a image file',
                    });
                    return;
                }



                var fileTransfer = new FileTransfer();
                var temp = cordova.file.tempDirectory + selectedFile.name;

                console.dir(temp);

                fileTransfer.download(
                    uri,
                    temp,
                    function (entry) {
                        console.log("download complete: " + entry.toURL());
                        console.dir(entry);

                        $scope.company.new_image = entry.toURL();
                        $scope.$apply();
                        $ionicLoading.hide();


                    },
                    function (error) {
                        console.log("download error source " + error.source);
                        console.log("download error target " + error.target);
                        console.log("upload error code" + error.code);
                        console.log(error);
                        $ionicLoading.hide();
                    },
                    false,
                    {
                        headers: {
                            "Authorization": "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
                        }
                    });


            });


        }

        function dropboxError(error) {
            console.dir('db error');
            console.dir(error);
        }
    }

})