app.controller('DashboardCtrl', function ($scope, $stateParams, $http, $state, $ionicModal, ionicDatePicker) {

    console.dir('dash controller');

    $scope.date = {};
    $scope.projects = {};

    $scope.date['start'] = new Date(moment().subtract('days', '14'));
    $scope.date['end'] = new Date();

    $scope.startDatePicker = function () {
        var start = {
            callback: function (val) {  //Mandatory
                console.log('start: ' + val, new Date(val));

                $scope.date.start = new Date(val);

                delete window.start;
            },
            from: null, //Optional
            to: $scope.date.end, //Optional
            inputDate: $scope.date.start,      //Optional
            mondayFirst: true,          //Optional
            // disableWeekdays: [0],       //Optional
            closeOnSelect: true,       //Optional
            templateType: 'popup'       //Optional
        };

        ionicDatePicker.openDatePicker(start);
    };

    $scope.endDatePicker = function () {

        var end = {
            callback: function (val) {  //Mandatory
                console.log('end: ' + val, new Date(val));

                $scope.date.end = new Date(val);
                delete window.end;
            },
            from: $scope.date.start, //Optional
            to: null, //Optional
            inputDate: $scope.date.end,      //Optional
            mondayFirst: true,          //Optional
            // disableWeekdays: [0],       //Optional
            closeOnSelect: true,       //Optional
            templateType: 'popup'       //Optional
        };


        ionicDatePicker.openDatePicker(end);
    };


    $scope.onClick = function (points, evt) {
        console.log(points, evt);
    };

    // $scope.options = {
    //     loop: false,
    //     // effect: 'fade',
    //     speed: 500,
    // }

    // $scope.slider = data.slider;
    $scope.$on("$ionicSlides.sliderInitialized", function (event, sliderData) {
        // data.slider is the instance of Swiper
        $scope.slider = sliderData.slider;
    });


    $scope.nextSlide = function () {
        $scope.slider.slideNext();
    };
    $scope.prevSlide = function () {
        $scope.slider.slidePrev();
    };

    $ionicModal.fromTemplateUrl('templates/dashboard/_daterange.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modal = modal;
    });

    $scope.closeModal = function () {
        $scope.modal.hide();
    };
    $scope.dateRange = function () {
        $scope.modal.show();
    };


    var route = 'dashboard'
    $scope.loadDate = function () {
        $scope.loaded = null;
        $scope.load();
    }

    $scope.setTimeFrame = function(option) {
        $scope.date['end'] = new Date();

        var momentStart = 0;

        if ($scope.user.start_of_week)
            momentStart = $scope.user.start_of_week - 1;

        switch (option) {
            case 'thisweek':
                $scope.date['start'] = new Date(moment().startOf('isoWeek').add(momentStart, 'days'));
                $scope.date['end'] = new Date(moment().endOf('isoWeek').add(momentStart, 'days'));
                break;
            case 'lastweek':
                $scope.date['start'] = new Date(moment().subtract(1, 'weeks').startOf('isoWeek').add(momentStart, 'days'));
                $scope.date['end'] = new Date(moment().subtract(1, 'weeks').endOf('isoWeek').add(momentStart, 'days'));
                break;
            case 'thismonth':
                $scope.date['start'] = new Date(moment().startOf('month'));
                $scope.date['end'] = new Date(moment().endOf('month'));
                break;
            case 'lastmonth':
                $scope.date['start'] = new Date(moment().subtract(1, 'month').startOf('month'));
                $scope.date['end'] = new Date(moment().subtract(1, 'month').endOf('month'));
                break;
            case 'thisyear':
                $scope.date['start'] = new Date(moment().startOf('year'));
                $scope.date['end'] = new Date(moment().endOf('year'));
                break;
            case 'lastyear':
                $scope.date['start'] = new Date(moment().subtract(1, 'year').startOf('year'));
                $scope.date['end'] = new Date(moment().subtract(1, 'year').endOf('year'));
                break;
        }
        $scope.closeModal();
        $scope.loadDate();
    }

    $scope.load = function () {
        $scope.companyColors = [];
        $scope.projectColors = [];
        $scope.chartData = null;

        console.dir($scope.date);// return;

        var start = moment($scope.date.start).format('YYYY-MM-DD');
        var end = moment($scope.date.end).format('YYYY-MM-DD');

        console.dir(baseURL + route + '?start=' + start + '&end=' + end);
        $http({
            method: 'get',
            url: baseURL + route + '?start=' + start + '&end=' + end,

        }).success(function (data) {
            console.dir(data);

            $scope.loaded = true;

            $scope.startDate = new Date(data.data.dates.start);
            $scope.endDate = new Date(data.data.dates.end);

            $scope.total = data.data.data.total;
            $scope.companies = data.data.companies
            $scope.projects = data.data.projects
            $scope.tasks = data.data.tasks;
            $scope.users = data.data.users;

            var project = createChart(data['data'], 'projects');
            $scope.projectLabels = project.labels;
            $scope.projectSeries = project.series;
            $scope.projectOptions = project.options;
            $scope.projectData = project.data;

            var company = createChart(data['data'], 'companies');
            $scope.companyLabels = company.labels;
            $scope.companySeries = company.series;
            $scope.companyOptions = company.options;
            $scope.companyData = company.data;


            // var expenses = createChart(data['expenses']);
            // $scope.expenseLabels = expenses.labels;
            // $scope.expenseSeries = expenses.series;
            // $scope.expenseOptions = expenses.options;
            // $scope.expenseData = expenses.data;
            //
            // var invoices = createChart(data['invoices']);
            // $scope.invoiceLabels = invoices.labels;
            // $scope.invoiceSeries = invoices.series;
            // $scope.invoiceOptions = invoices.options;
            // $scope.invoiceData = invoices.data;

            $scope.chartData = true;

            $scope.series_employee = [];
            $scope.data_employee = [];


            $scope.$broadcast('scroll.refreshComplete');


        }).error(function (data, status, headers, config) {
            console.dir('getting chart data error');

            $scope.$broadcast('scroll.refreshComplete');
            $scope.loaded = true;
            // alert('Couldn\'t generate report');

        });
    }

    function createChart(data, type) {
        $scope.items = data;
        console.log(data);
        var days = moment($scope.date.end).diff(moment($scope.date.start), 'days');

        var labels = [];
        var chartData = [];
        var series = [];
        var options = {
            yAxisLabel: "Hours1",
            label: "Hours",
            borderWidth: 0,
            borderColor: '#000',
            elements: {
                rectangle: {
                    borderSkipped: 'left',
                    borderWidth: 2,
                }
            },
            legend: {
                tooltips: {
                    mode: 'label'

                },
                display: true,
                position: 'bottom'
            },
            grid: {
                borderWidth: 10,
                label: "Hours",

            },
            xaxis: {
                label: "Hours",

            }
        }


        // return;

        if (days > 31) {
            angular.forEach($scope.items.data.month, function (value, date) {
                var tmp = moment(date, "YYYY-MM-DD").format('MMM YYYY');
                labels.push(tmp);
            })
        } else {
            angular.forEach($scope.items.data.dates, function (value, date) {
                var tmp = moment(date).format('MMM Do');
                labels.push(tmp);
            })
        }

        if (type == 'companies') {
            var loop = $scope.items.companies
        } else if (type =='projects') {
            var loop = $scope.items.projects
        }


        angular.forEach(loop, function (company, id) {

            console.log(company);
            console.log(type);
            series.push(company.name);

            if (type == 'companies') $scope.companyColors.push(company.color);
            if (type == 'projects') $scope.projectColors.push(company.color);

            var data = [];

            if (days > 31) {
                angular.forEach($scope.items.data.month, function (hour, key) {
                    if (type == 'companies') {
                        data.push(hour.company[id].hours.toFixed(3));
                    } else if (type =='projects') {

                        if (hour.project && hour.project[id]) {
                            data.push(hour.project[id].hours.toFixed(3));
                        } else {
                            data.push(0);
                        }
                    }

                });
            } else {
                angular.forEach($scope.items.data.dates, function (hour, key) {

                    if (type == 'companies') {
                        data.push(hour.company[id].hours.toFixed(3));
                    } else if (type =='projects') {

                        if (hour.project && hour.project[id]) {
                            data.push(hour.project[id].hours.toFixed(3));
                        } else {
                            data.push(0);
                        }
                    }
                });
            }

            chartData.push(data);

        })

        return {
            'labels': labels,
            'series': series,
            'options': options,
            'data': chartData
        };
    }


    // var config = {
    //     type: 'horizontalBar',
    //     data: {
    //         labels: ["Eating", "Drinking", "Sleeping", "Designing", "Coding", "Cycling", "Running"],
    //         datasets: [{
    //             label: "My First dataset",
    //             backgroundColor: "rgba(255,99,132,0.2)",
    //             borderColor: "rgba(255,99,132,1)",
    //             hoverBackgroundColor: "rgba(255,99,132,0.5)",
    //             hoverBorderColor: "rgba(255,99,132,1)",
    //             data: [65, -59, -90, 81, 56, 55, 40],
    //         }, {
    //             label: "My Second dataset",
    //             backgroundColor: "rgba(54,162,235,0.2)",
    //             borderColor: "rgba(54,162,235,1)",
    //             hoverBackgroundColor: "rgba(54,162,235,0.5)",
    //             hoverBorderColor: "rgba(54,162,235,1)",
    //             data: [28, -48, -40, 19, 96, 27, 100]
    //         }]
    //     },
    //     options: {
    //         scales: {
    //             xAxes: [{
    //                 stacked: true
    //             }],
    //             yAxes: [{
    //                 stacked: true
    //             }]
    //         }
    //     }
    // };
    //
    // var ctx = document.getElementById("testChart").getContext("2d");
    // new Chart(ctx, config);


    //var route = 'client'
    //
    //$scope.clients = [];
    //
    //$http({
    //    method: 'get',
    //    url: baseURL + route,
    //
    //}).success(function (data) {
    //    console.dir(data);
    //
    //    console.dir('getting clients success');
    //    $scope.clients.push.apply($scope.clients, data['clients']);
    //
    //}).error(function (data, status, headers, config) {
    //    console.dir('getting clients error');
    //
    //});
    //
    //$scope.editClient = function (client) {
    //    console.dir('setting client');
    //    console.dir(client);
    //    $scope.client = client;
    //
    //    store.set('client', client);
    //    //$state.go('app.company-edit', { company: $scope.company });
    //};


})

// .config(['ChartJsProvider', function (ChartJsProvider) {
//     // Configure all charts
//     ChartJsProvider.setOptions({
//         chartColors: ['#FF5252', '#FF8A80', '#000'],
//         borderWidth: 15,
//         borderColor: '#000',
//         chartOptions: {
//             borderWidth: 15,
//             borderColor: '#000',
//         }
//     });
//     // Configure all line charts
//     ChartJsProvider.setOptions('line', {
//         datasetFill: false
//     });
// }])