app.controller('EmployeeCtrl', function ($scope, $stateParams, $http, $state, UserService, $ionicPopup) {
    console.dir('employee controller');

    $scope.clients = UserService.getClients();
    $scope.employees = UserService.getEmployees();
    $scope.user = UserService.getUser();

    $scope.employees = $scope.user.employees;

    console.dir($scope.employees);

    $scope.refresh = function () {
        var route = 'employee';

        $http({
            method: 'get',
            url: baseURL + route,

        }).success(function (data) {
            console.dir(data);

            console.dir('getting employees success');
            $scope.employees = data['employees'];
            UserService.setEmployees($scope.employees);

            $scope.$broadcast('scroll.refreshComplete');
        }).error(function (data, status, headers, config) {
            console.dir('getting employees error');
            $scope.$broadcast('scroll.refreshComplete');
        });
    }

    $scope.archiveEmployee = function (employee) {
        var route = 'employee/archive';

        $http({
            method: 'post',
            url: baseURL + route,
            data: {'employee_id': employee.id},

        }).success(function (data) {
            console.dir(data);

            if (data['status'] == 'success') {
                console.dir('archive toggle employee - success');

                employee = data.employee;

                $('#employee-'+employee.id).slideUp("normal", function() {
                    UserService.setEmployee(data.employee);
                });


            } else {
                console.dir('archive employee - success but error');
            }

        }).error(function (data) {
            console.dir('archive employee - error');
            console.dir(data);
        });

    }

    $scope.deleteEmployee = function (employee) {
        var route = 'employee/delete';

        $http({
            method: 'post',
            url: baseURL + route,
            data: {'employee_id': employee.id},

        }).success(function (data) {
            console.dir(data);

            if (data['status'] == 'success') {
                console.dir('delete employee - success');

                //UserService.setEmployee(data.employee);
                delete employee;


            } else {
                console.dir('delete employee - success but error');
            }

        }).error(function (data) {
            console.dir('delete employee - error');
            console.dir(data);
        });
    }
})




app.controller('EmployeeEditCtrl', function ($scope, $stateParams, $http, $ionicModal, UserService, $ionicPopup, $state, ionicDatePicker,
                                            $ionicActionSheet, $ionicLoading) {

    // $state.go('app.employee.active');
    // $ionicPopup.alert({
    //     title: 'Coming Soon.',
    //     subTitle: 'This feature isn\'t quite ready yet. Feel free to look around. You will not be able to save anything just yet',
    // });
    // return;


    console.dir('employees edit controller');
    var employees_id = $stateParams.employee_id;

    //$scope.employees = angular.copy($scope.data.companies[employees_id]);
    $scope.employees = UserService.getEmployees(employees_id);
    


});
