app.controller('ExpenseCtrl', function ($scope, $stateParams, $http, $state, store, UserService) {


    var route = 'expense'
    $scope.expenses = UserService.getExpenses();
    $scope.done = null;

    $scope.$on('reloaded', function (event, data) {
        $scope.expenses = UserService.getExpenses();
    });

    console.dir($scope.expenses);

    $scope.load = function () {

        $scope.loaded = true;
        var offset = $(".expense").length;

        if ($scope.refreshExpenses) {
            offset = 0;
        }


        $http({
            method: 'get',
            url: baseURL + route + '?offset=' + offset,

        }).success(function (data) {
            console.dir(data);

            console.dir('getting expenses success');

            if ($scope.refreshExpenses) {
                $scope.expenses = data['expenses'];
                UserService.setExpenses(data['expenses']);
                UserService.setExpenseCategories(data['expense_categories']);

                $scope.refreshExpenses = null;
            } else {
                $scope.expenses.push.apply($scope.expenses, data['expenses']);
            }

            console.dir($scope.expenses);
            if (data['expenses'].length == 0) $scope.done = true;

            //if (data['expenses'].length == 0) $scope.done = true;
            //$scope.done = true;
            //$scope.done = true;
            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');


        }).error(function (data, status, headers, config) {
            console.dir('getting expenses error');
            $scope.done = true;
            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');

        });
    };

    $scope.refresh = function () {

        console.dir('start refresh');
        $scope.refreshExpenses = true;
        $scope.done = null;
        $scope.load();

    }

    $scope.deleteExpense = function (expense) {
        console.dir('delete expense');
        console.dir(expense);

        var route = 'expense/' + expense.id;

        $http({
            method: 'delete',
            url: baseURL + route,

        }).success(function (data) {
            console.dir('del expenses success');
            console.dir(data);

            if (data['status'] == 'success') {
                //$scope.expense = UserService.getExpense(expense.id);

                $('#expense-' + expense.id).slideUp("normal", function () {
                    var index = $scope.expenses.indexOf(expense);
                    $scope.expenses.splice(index, 1);

                    store.set('expenses', $scope.expenses);
                });


            } else {
                console.dir('del expenses suc error');
            }


        }).error(function (data) {
            console.dir('del expenses error');

        });

    };

})

app.controller('ExpenseEditCtrl', function ($scope, $stateParams, $http, $state, store, $cordovaCapture, $ionicModal, UserService,
                                            $cordovaFileTransfer, localStorageService, $ionicLoading, $ionicActionSheet, $ionicHistory,
                                            $timeout, $ionicPopup, $localStorage, ionicDatePicker, $ionicPlatform) {
    console.dir('expense edit ctrl');

    var expense_id = $stateParams.expense_id;
    var option = $stateParams.option;

  var large = angular.copy(UserService.getLarge());

  $scope.large = false;
  if (large && (large.employee || large.projects || large.companies || large.clients)) $scope.large = true;

    $scope.expense = UserService.getExpense(expense_id);
    // $scope.expense_categories = $localStorage.data.expense_categories;
    $scope.expense_categories = UserService.getExpenseCategories();

    $scope.projects = UserService.getActiveProjects();
    $scope.project = UserService.getActiveProjects($scope.expense.project);

  // Employee
  var employer_companies = UserService.getEmployerCompanies();
  var employer_projects = UserService.getEmployerProjects();
  $scope.projects = jQuery.merge($scope.projects, employer_projects);


    if (expense_id == 'new') {
        $scope.expense.date_added = new Date();
        $scope.expense.project = $scope.projects[0];
        $scope.expense.category = $scope.expense_categories[0];
    } else {
        $scope.expense.date_added = moment($scope.expense.date_added).toDate();
    }

    console.dir($scope.expense);

    $scope.search = function (q) {

      $('#project-search').show();

      var route = 'timesheet/projects';
      $http({
        type: 'GET',
        url: baseURL + route + '?q=' + this.projectSearch,
        // data: {q: this.projectSearch},

      }).success(function (data) {
        console.dir(data);
        $('#project-search').hide();

        $scope.searchProjects = data.projects;

      });

    };

    $scope.openDatePicker = function () {
        var date = {
            callback: function (val) {  //Mandatory
                $scope.expense.date_added = new Date(val);
                delete window.date;
            },
            from: null, //Optional
            // to: $scope.date.end, //Optional
            inputDate: $scope.expense.date_added,      //Optional
            mondayFirst: true,          //Optional
            // disableWeekdays: [0],       //Optional
            closeOnSelect: true,       //Optional
            templateType: 'popup'       //Optional
        };

        ionicDatePicker.openDatePicker(date);
    };

    $scope.actionSheet = function () {

        if (!$scope.expense.receipt && !$scope.expense.new_receipt) {
            var buttons = [
                {text: 'Take Picture'},
                {text: 'Photo Library'}
            ]
            var remove = null;

        }

        if ($scope.expense.new_receipt) {

            var buttons = [
                {text: 'View Receipt'},
                {text: 'Take Picture'},
                {text: 'Photo Library'},
            ]

            var remove = 'Remove New Receipt';
        } else if ($scope.expense.receipt) {

            var buttons = [
                {text: 'View Receipt'},
                {text: 'Take Picture'},
                {text: 'Photo Library'},
            ]

            var remove = 'Remove Receipt';
        }

        // Show the action sheet
        var hideSheet = $ionicActionSheet.show({
            buttons: buttons,
            titleText: 'Expense Receipt',
            destructiveText: remove,
            cancelText: 'Cancel',
            cancel: function () {
                // add cancel code..
            },
            destructiveButtonClicked: function () {
                console.dir('remove image');
                $scope.removeImage();
                return true;
            },
            buttonClicked: function (index) {
                if (!$scope.expense.receipt && !$scope.expense.new_receipt) {
                    if (index == 0) $scope.captureImage();
                    if (index == 1) $scope.pictureLibrary();
                } else {
                    if (index == 0) $scope.openModal();
                    if (index == 1) $scope.captureImage();
                    if (index == 2) $scope.pictureLibrary();
                }
                return true;
            }
        });

    };

    $ionicModal.fromTemplateUrl('templates/expense/_receipt.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modal = modal;
    });

    $scope.openModal = function () {
        route = 'expense/' + $scope.expense.id + '/receipt';

        // Show existing receipt if the user hasnt picked a new one yet
        if ($scope.expense.receipt && !$scope.expense.new_receipt) {

            $http({
                method: 'get',
                url: baseURL + route,
                contentType: "image/jpg",

            }).success(function (data) {
                console.dir(data);
                $scope.image = data['image'];
                $scope.modal.show();

            }).error(function (data, status, headers, config) {
                console.dir(data);
                console.dir('getting expenses error');

            });
        } else {

            // show new image
            $scope.image = $scope.expense.new_receipt;
            $scope.modal.show();
        }

    };

    $scope.closeModal = function () {
        $scope.modal.hide();
    };

    $scope.new = false;
    $scope.newCategory = function () {
        $scope.expense.category = null;
        $scope.new = !$scope.new;
    }




    $scope.removeImage = function () {

        if ($scope.expense.receipt) {
            var route = "expense/" + $scope.expense.id + '/receipt';

            $http({
                method: 'delete',
                url: baseURL + route,

            }).success(function (data) {
                console.dir(data);

                if (data['status'] == 'success') {
                    console.dir('delete expense receipt - success');


                    // Using temp incase user changed forms but didnt save company info.
                    var temp = UserService.getExpense($scope.expense.id);
                    $scope.expense.receipt = null;
                    UserService.setExpense(temp);


                    $ionicPopup.alert({
                        title: 'Expense receipt has been deleted',
                    });


                } else {
                    console.dir('delete expense logo - success but error');
                }

            }).error(function (data) {
                console.dir('delete expense receipt - error');
                console.dir(data);
            });


        } else {
            $scope.expense.new_receipt = null;
        }
    }


    $scope.pictureLibrary = function () {
        //$scope.image = document.getElementById('myImage');
        //if (navigator.camera) {
        console.dir('video from library');

        var options = {
            sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY,
            mediaType: navigator.camera.MediaType.PICTURE,
            correctOrientation: true,
            targetHeight: 1000,
            targetWidth: 1000,
        };
        console.dir(options);

        navigator.camera.getPicture(function (pictureData) {
            // Do any magic you need

            console.dir('picture from library success');
            console.dir(pictureData);

            setTimeout(function () {
                $scope.$apply(function () {
                    $scope.expense.new_receipt = pictureData;
                });
            }, 100);

        }, function (err) {
            console.dir('picture from library error');
            console.dir(err);
        }, options);
    };

    $scope.captureImage = function () {
        console.dir('capture image');

        var options = {
            correctOrientation: true,
            sourceType: navigator.camera.PictureSourceType.CAMERA,
            mediaType: navigator.camera.MediaType.PICTURE,
        };

        navigator.camera.getPicture(function (pictureData) {
            console.dir('picture success');
            console.dir(pictureData);
            $timeout(function () {

                $scope.expense.new_receipt = pictureData;
                $scope.$apply();
            }, 1000);
            return true;
        }, function (err) {
            console.dir('picture from library error');
            console.dir(err);
        }, options);

    };

    $scope.closeModal = function () {
        $scope.modal.hide();
        $scope.modal2.hide();
        $scope.modal3.hide();

    };

  if (!$scope.large) projectUrl = 'templates/expense/_projects.html';
  else projectUrl = 'templates/expense/_project_search.html';

    $ionicModal.fromTemplateUrl(projectUrl, {
        scope: $scope,
        animation: 'slide-in-left',
    }).then(function (modal) {
        $scope.modal2 = modal;
    });

    $ionicModal.fromTemplateUrl('templates/expense/_categories.html', {
        scope: $scope,
        animation: 'slide-in-left',
    }).then(function (modal) {
        $scope.modal3 = modal;
    });

    $scope.openProjectsModal = function () {
        $scope.modal2.show();
    };
    $scope.openCategoriesModal = function () {
        $scope.modal3.show();
    };

    $scope.setProject = function (project) {
        $scope.expense.project = project;
        $scope.modal2.hide();
    }

  $scope.setSearchedProject = function (project) {

    let p;
    let c;

    if (project.company_name) {
      c = {name: project.company_name, id: project.company_id};
      p = {name: project.project_name, id: project.id, company: c};
    } else {
      p = project;
    }


    $scope.expense.project = p;
    $scope.modal2.hide();
  }

    $scope.setCategory = function (category) {
        $scope.expense.category = category;
        $scope.modal3.hide();
    }


    $scope.updateExpense = function (form) {

        console.dir($scope.expense);
        if (!form.$valid) {
            return false;
        }

        var newDate = moment($scope.expense.date_added).format('YYYY-MM-DD');
        var data = {
            expense: {
                project: $scope.expense.project.id,
                category: $scope.expense.category.id,
                amount: $scope.expense.amount,
                billable: $scope.expense.billable,
                description: $scope.expense.description,
                receipt: $scope.expense.receipt,
                id: $scope.expense.id,
                dateAdded: newDate
            }
        };

        if ($scope.new) {
            data.expense.newExpense = $scope.expense.category.name;
            data.expense.newExpensePrice = $scope.expense.category.price;
            data.expense.newExpensePer = $scope.expense.category.per;
            data.expense.category = null;
        }

        console.dir(data);
        var route = 'expense/edit';

        if ($scope.expense.new_receipt) {

            console.dir('new receipt upload');

            var options = new FileUploadOptions();
            options.fileKey = "file";
            options.fileName = 'receipt.jpg';
            options.mimeType = "image/jpg";
            options.chunkedMode = false;
            // options.params = data;
            // options.params = { "expense": {"project":1141,"category":50,"amount":567,"dateAdded":"2019-11-19"}};
            options.params = {
                expense: JSON.stringify(data.expense)
            };

            options.headers = {Authorization: 'Bearer ' + localStorageService.get('authorizationData').token}

            $ionicLoading.show({
                template: '<ion-spinner class="light"></ion-spinner><br />Uploading...',
                content: '',
            });

            console.dir('upload start');
            console.dir(options);


            $cordovaFileTransfer.upload(baseURL + route, $scope.expense.new_receipt, options, true).then(function (result) {
                    console.dir('receipt image uploaded');
                    result = JSON.parse(result.response);

                    console.dir(result);
                    console.dir(result.status);

                    if (result.status != 'success') {
                        $ionicLoading.hide();
                        $ionicPopup.alert({
                            title: 'Unable to save expense',
                        });
                        return;
                    }

                    console.log("SUCCESS: " + JSON.stringify(result.response));

                    UserService.setExpense(result.expense);
                    $scope.expenses = UserService.getExpenses();

                    if (result.new_category) {
                        UserService.setExpenseCategory(result.new_category)
                    }

                    console.dir($scope.expenses);

                    $ionicLoading.hide();
                    $ionicHistory.goBack();
                    $ionicPopup.alert({
                        title: 'Expense Saved!',
                    });


                }, function (err) {
                    $ionicLoading.hide();

                    console.log("ERROR1");
                    console.log(JSON.stringify(err));

                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: 'Error uploading',
                    });
                }
            );
        } else {
            console.dir('no receipt');

            $ionicLoading.show({
                template: '<ion-spinner class="light"></ion-spinner><br />Saving...',
                content: '',
            });

            $http({
                method: 'post',
                url: baseURL + route,
                data: data,

            }).success(function (data) {
                console.dir(data);


                if (data['status'] == 'success') {
                    console.dir('edit expense - success');
                    UserService.setExpense(data.expense);

                    if (data.new_category) {
                        UserService.setExpenseCategory(data.new_category)
                    }

                    $scope.expenses = UserService.getExpenses();
                    console.dir($scope.expenses);

                    $ionicPopup.alert({
                        title: 'Expense Saved!',
                    });

                    $state.go('app.expense');

                } else {
                    console.dir('edit expense - success but error');
                }
                console.dir(data);

            }).error(function (data) {
                console.dir('edit expense - error');
                console.dir(data);
                $ionicLoading.hide();
            }).then(function () {
                $ionicLoading.hide();
            });
        }
    }

    $ionicPlatform.ready(function () {
        if (option == 'camera') {
            $scope.captureImage();
        }
    });


})

// app.directive('currency', function () {
//     return {
//         require: 'ngModel',
//         link: function (elem, $scope, attrs, ngModel) {
//             ngModel.$formatters.push(function (val) {
//                 return '$' + val
//             });
//             ngModel.$parsers.push(function (val) {
//                 return val.replace(/^\$/, '')
//             });
//         }
//     }
// })
