app.controller('InvoiceCtrl', function ($scope, $stateParams, $http, $state, store, $ionicActionSheet, UserService,
                                        $ionicPopup, $translate) {

    var route = 'invoice';
    $scope.invoices = UserService.getInvoices();

    console.dir($scope.invoices);
    $scope.doneActive = null;
    $scope.doneArchived = null;

    $ionicPopup.alert({
        title: $translate.instant('invoice.soon.title'),
        subTitle: $translate.instant('invoice.soon.subtitle'),
    });

    $scope.load = function (type) {

        $scope.loaded = true;
        if (type == 'active')
            var offset = $(".invoice-active").length;
        if (type == 'archived')
            var offset = $(".invoice-archived").length;

        if ($scope.refreshInvoices) {
            offset = 0;
        }

        $http({
            method: 'get',
            url: baseURL + route + '?offset=' + offset + '&type=' + type,

        }).success(function (data) {
            console.dir(data);

            console.dir('getting invoices success');

            if ($scope.refreshExpenses) {
                console.dir('refresh');
                $scope.invoices = data['invoices'];
                UserService.setInvoices(data['invoices']);

                $scope.refreshInvoices = null;
            } else {
                console.dir(type);

                if (type == 'active') {
                    console.dir(data['invoices']['active']);
                    $scope.invoices.active.push.apply($scope.invoices.active, data['invoices']['active']);
                    if (data['invoices']['active'].length == 0) $scope.doneActive = true;
                }

                if (type == 'archived') {
                    console.dir(data['invoices']['archived']);
                    $scope.invoices.archived.push.apply($scope.invoices.archived, data['invoices']['archived']);
                    if (data['invoices']['archived'].length == 0) $scope.doneArchived = true;
                }


            }


            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.$broadcast('scroll.refreshComplete');


        }).error(function (data, status, headers, config) {
            console.dir('getting invoices error');
            $scope.$broadcast('scroll.refreshComplete');
            $scope.doneArchived = true;
            $scope.doneActive = true;

        });
    };

    $scope.loadActive = function () {
        var type = 'active';
        $scope.load(type);
    }

    $scope.loadArchived = function () {
        var type = 'archived';
        $scope.load(type);
    }

    $scope.refresh = function () {

        var type = 'all';
        console.dir('start refresh');
        $scope.doneActive = null;
        $scope.doneArchived = null;
        $scope.refreshInvoices = true;

        $scope.invoices.active = data['invoices']['active'];
        $scope.invoices.archived = data['invoices']['archived'];

    }


    $scope.deleteInvoice = function (invoice) {
        console.dir('delete invoice');
        console.dir(invoice);

        var route = 'invoice/' + invoice.id;

        $http({
            method: 'delete',
            url: baseURL + route,

        }).success(function (data) {
            console.dir('del invoices success');
            console.dir(data);

            if (data['status'] == 'success') {
                //$scope.invoice = UserService.getInvoice(invoice.id);

                $('#invoice-' + invoice.id).slideUp("normal", function () {
                    var index = $scope.invoices.indexOf(invoice);
                    $scope.invoices.splice(index, 1);

                    store.set('invoices', $scope.invoices);
                });


            } else {
                console.dir('del invoices suc error');
            }


        }).error(function (data) {
            console.dir('del invoices error');

        });

    };


    $scope.archiveInvoice = function (invoice) {
        var route = 'invoice/archive';

        $http({
            method: 'post',
            url: baseURL + route,
            data: {'invoice_id': invoice.id},

        }).success(function (data) {
            console.dir(data);

            if (data['status'] == 'success') {
                console.dir('archive toggle invoice - success');

                invoice = data.invoice;

                UserService.setInvoice(data.invoice);


            } else {
                console.dir('archive invoice - success but error');
            }

        }).error(function (data) {
            console.dir('archive invoice - error');
            console.dir(data);
        });

    }

});


app.controller('InvoiceEditCtrl', function ($scope, $stateParams, $http, $ionicModal, UserService, $ionicPopup, $state, ionicDatePicker,
                                            $ionicActionSheet, $ionicLoading) {

    // $state.go('app.invoice.active');
    // $ionicPopup.alert({
    //     title: 'Coming Soon.',
    //     subTitle: 'This feature isn\'t quite ready yet. Feel free to look around. You will not be able to save anything just yet',
    // });
    // return;


    var invoice = $stateParams.invoice_id;

    $scope.invoice = UserService.getInvoice(invoice);
    $scope.companies = UserService.getCompanies();
    $scope.clients = UserService.getClients();

    $scope.tax = {tax: 0, tax2: 0, discount: 0};


    $scope.updateNumbers = function () {
        console.dir($scope.invoice);
        $scope.subtotal = 0.00;
        $scope.payments = 0.00;
        $scope.total = 0.00;

        $scope.invoice.items.forEach(function (item) {
            $scope.subtotal = $scope.subtotal + item.price * item.quantity;
        });

        console.dir('payments');
        console.dir($scope.invoice.payments);
        $scope.invoice.payments.forEach(function (item) {
            $scope.payments = $scope.payments + item.amount;
        });

        $scope.total = $scope.subtotal - $scope.payments;
        $scope.tax_total = $scope.invoice.tax * $scope.subtotal / 100;
        $scope.tax2_total = $scope.invoice.tax2 * $scope.subtotal / 100;
        $scope.discount_total = $scope.invoice.discount * $scope.subtotal / 100;

        if ($scope.invoice.tax) $scope.total = $scope.total + $scope.tax_total;
        if ($scope.invoice.tax2) $scope.total = $scope.total + $scope.tax2_total;
        if ($scope.invoice.discount) $scope.total = $scope.total - $scope.discount_total;

    };


    console.dir('edit invoice');
    console.dir($scope.invoice);

    $scope.openTaxModal = function () {

        if (!$scope.taxModal) {
            $ionicModal.fromTemplateUrl('templates/invoice/_taxes.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.taxModal = modal;
                $scope.taxModal.show();

                $scope.tax.tax = $scope.invoice.tax;
                $scope.tax.tax2 = $scope.invoice.tax2;
                $scope.tax.discount = $scope.invoice.discount;
            });
        } else {
            $scope.taxModal.show();
        }
    };
    $scope.openPaymentsModal = function () {

        if (!$scope.paymentsModal) {
            $ionicModal.fromTemplateUrl('templates/invoice/_payments.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.paymentsModal = modal;
                $scope.paymentsModal.show();
            });
        } else {
            $scope.paymentsModal.show();
        }
    };
    $scope.openCompanyModal = function () {

        if (!$scope.companyModal) {
            $ionicModal.fromTemplateUrl('templates/invoice/_companies.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.companyModal = modal;
                $scope.companyModal.show();
            });
        } else {
            $scope.companyModal.show();
        }
    };
    $scope.openClientModal = function () {

        if (!$scope.clientModal) {
            $ionicModal.fromTemplateUrl('templates/invoice/_clients.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.clientModal = modal;
                $scope.clientModal.show();
            });
        } else {
            $scope.clientModal.show();
        }
    };


    $scope.closeModal = function () {
        if ($scope.taxModal) $scope.taxModal.hide();
        if ($scope.paymentsModal) $scope.paymentsModal.hide();
        if ($scope.itemModal) $scope.itemModal.hide();
        if ($scope.companyModal) $scope.companyModal.hide();
        if ($scope.clientModal) $scope.clientModal.hide();
        if ($scope.timesheetModal) $scope.timesheetModal.hide();
        $scope.updateNumbers();
    };

    $scope.setTaxes = function () {

        console.dir($scope.tax);
        $scope.invoice.tax = $scope.tax.tax;
        $scope.invoice.tax2 = $scope.tax.tax2;
        $scope.invoice.discount = $scope.tax.discount;

        console.dir($scope.tax);
        console.dir($scope.invoice);

        $scope.taxModal.hide();
    };

    $ionicModal.fromTemplateUrl('templates/invoice/_item.html', {
        scope: $scope,
        animation: 'slide-in-left'
    }).then(function (modal) {
        $scope.itemModal = modal;
    });

    $scope.editItemModal = function (item) {
        console.dir(item);
        console.dir($scope.invoice.items.indexOf(item));

        if (item) {
            $scope.index = $scope.invoice.items.indexOf(item);
            $scope.item = angular.copy(item);
        } else {
            $scope.item = {};
        }

        $scope.itemModal.show();
    }

    $scope.showTimesheetModal = function (item) {
        $scope.timesheet = {};

        $scope.timesheet['start'] = new Date(moment().subtract('days', '14'));
        $scope.timesheet['end'] = new Date();


        if (!$scope.timesheetModal) {
            $ionicModal.fromTemplateUrl('templates/invoice/_item-from-timesheet.html', {
                scope: $scope,
                animation: 'slide-in-left'
            }).then(function (modal) {
                $scope.timesheetModal = modal;
                $scope.timesheetModal.show();

            });
        } else {
            $scope.timesheetModal.show();
        }
    }


    $scope.setItem = function (form) {

        if (!form.$valid) {
            console.dir('item missing field');
            return false;
        }

        if ($scope.index >= 0) {
            $scope.originalItem = $scope.item;
            $scope.invoice.items[$scope.index] = $scope.item;
        } else {
            $scope.invoice.items.push($scope.item);
        }

        console.dir($scope.invoice.items);
        $scope.itemModal.hide();
        $scope.updateNumbers();
    }

    $scope.startTimesheetDatePicker = function () {
        var start = {
            callback: function (val) {  //Mandatory
                console.log('start: ' + val, new Date(val));

                $scope.timesheet.start = new Date(val);

                delete window.start;
            },
            from: null, //Optional
            to: $scope.timesheet.end, //Optional
            inputDate: $scope.timesheet.start,      //Optional
            mondayFirst: true,          //Optional
            // disableWeekdays: [0],       //Optional
            closeOnSelect: true,       //Optional
            templateType: 'popup'       //Optional
        };

        ionicDatePicker.openDatePicker(start);
    };
    $scope.endTimesheetDatePicker = function () {

        var end = {
            callback: function (val) {  //Mandatory
                console.log('end: ' + val, new Date(val));

                $scope.timesheet.end = new Date(val);
                delete window.end;
            },
            from: $scope.timesheet.start, //Optional
            to: null, //Optional
            inputDate: $scope.timesheet.end,      //Optional
            mondayFirst: true,          //Optional
            // disableWeekdays: [0],       //Optional
            closeOnSelect: true,       //Optional
            templateType: 'popup'       //Optional
        };


        ionicDatePicker.openDatePicker(end);
    };


    $scope.issueDatePicker = function () {

        var toDate = $scope.invoice.date_due || null;


        var issue = {
            callback: function (val) {  //Mandatory
                console.log('start: ' + val, new Date(val));

                $scope.invoice.date_added = new Date(val);

                delete window.start;
            },
            from: null, //Optional
            to: toDate, //Optional
            inputDate: new Date($scope.invoice.date_added),      //Optional
            mondayFirst: true,          //Optional
            // disableWeekdays: [0],       //Optional
            closeOnSelect: true,       //Optional
            showTodayButton: true,
            templateType: 'popup'       //Optional
        };

        ionicDatePicker.openDatePicker(issue);
    };
    $scope.dueDatePicker = function () {

        var from = new Date($scope.invoice.date_added);
        var inputDate = $scope.invoice.date_due || new Date();

        var due = {
            callback: function (val) {  //Mandatory
                console.log('end: ' + val, new Date(val));

                $scope.invoice.date_due = new Date(val);
                delete window.end;
            },
            from: from, //Optional
            to: null, //Optional
            inputDate: inputDate,      //Optional
            mondayFirst: true,          //Optional
            // disableWeekdays: [0],       //Optional
            closeOnSelect: true,       //Optional
            showTodayButton: true,
            templateType: 'popup'       //Optional
        };


        if ($scope.invoice.date_due) {
            // $scope.actionSheet = function () {

            // Show the action sheet
            $ionicActionSheet.show({
                buttons: [
                    {text: 'New Due Date'},
                ],
                destructiveText: 'Clear Due Date',

                titleText: 'Due Date',
                cancelText: 'Cancel',
                cancel: function () {
                    // add cancel code..
                },
                buttonClicked: function (index) {
                    if (index == 0) ionicDatePicker.openDatePicker(due);
                    return true;
                },
                destructiveButtonClicked: function () {
                    $scope.invoice.date_due = null;
                    return true;
                }
            });

        } else {
            ionicDatePicker.openDatePicker(due);
        }
    };

    $scope.newItem = function () {

        var buttons = [
            {text: 'Blank Item'},
            {text: 'From Timesheets'},
            {text: 'All Un-invoiced Hours'},
            {text: 'All Un-invoiced Expenses'}
        ]

        // Show the action sheet
        var hideSheet = $ionicActionSheet.show({
            buttons: buttons,
            titleText: 'Adding a new Item',
            // destructiveText: remove,
            cancelText: 'Cancel',
            cancel: function () {
                // add cancel code..
            },
            destructiveButtonClicked: function () {
                return true;
            },
            buttonClicked: function (index) {
                // if (!$scope.expense.image && !$scope.expense.receipt) {
                if (index == 0) $scope.editItemModal();
                if (index == 1) $scope.showTimesheetModal();
                // } else {
                //     if (index == 0) $scope.openModal();
                //     if (index == 1) $scope.captureImage();
                //     if (index == 2) $scope.pictureLibrary();
                // }
                return true;
            }
        });

    };


    $scope.updateInvoice = function (form) {

        console.dir($scope.invoice);
        // return;

        var data = {
            invoice: $scope.invoice
        };

        $ionicLoading.show({
            template: '<ion-spinner class="light"></ion-spinner><br />Saving...',
            content: '',
        });

        var route = 'invoice/edit';
        $http({
            method: 'post',
            url: baseURL + route,
            data: data,

        }).success(function (data) {
            console.dir(data);

            if (data['status'] == 'success') {
                console.dir('edit invoice - success');

                UserService.setInvoice(data.invoice);
                $scope.invoice = invoice;

                $ionicPopup.alert({
                    title: 'Invoice Saved!',
                });

                $ionicHistory.goBack();

            } else {
                console.dir('edit client - success but error');
            }

        }).error(function (data) {
            console.dir('edit invoice - error');
            console.dir(data);
        }).then(function () {
            $ionicLoading.hide();
        });
    };


});

app.controller('InvoiceEmailCtrl', function ($scope, $stateParams, $http, $state, UserService) {
    var invoice = $stateParams.invoice_id;
    $scope.invoice = UserService.getInvoice(invoice);

})

