app.controller('ProjectCtrl', function ($scope, $stateParams, $http, $state, store, $ionicActionSheet, UserService, $animate, $timeout) {

    var route = 'project'

    $scope.done = null;

    $scope.data = store.get('misc');

    $scope.projects = UserService.getProjects();

    $scope.activeProjects = $scope.projects['active'];
    $scope.archivedProjects = $scope.projects['archived'];

    $scope.$on('reloaded', function (event, data) {
        $scope.projects = UserService.getProjects();
        $scope.activeProjects = $scope.projects['active'];
        $scope.archivedProjects = $scope.projects['archived'];
    });

    console.dir($scope.projects);
    $animate.enabled(false);

    $scope.refresh = function () {
        $http({
            method: 'get',
            url: baseURL + route,

        }).success(function (data) {
            console.dir(data);
            console.dir('getting projects success');

            $scope.activeProjects = data.projects['active'];
            $scope.archivedProjects = data.projects['archived'];

            UserService.setProjects(data.projects);

            $scope.$broadcast('scroll.refreshComplete');


        }).error(function (data, status, headers, config) {
            console.dir('getting projects error');
            $animate.enabled(true);
            $scope.$broadcast('scroll.refreshComplete');

        }).then(function() {
            console.dir('on');
            $timeout(function () {
                $animate.enabled(true);
            });
        });
    };


    $scope.actionSheet = function (timesheet) {
        console.dir('action sheet');

        // Show the action sheet
        var hideSheet = $ionicActionSheet.show({
            buttons: [
                {text: 'Email Project'},
                {text: 'Edit'},
                {text: 'Archive'}
            ],
            titleText: 'Timesheet',
            cancelText: 'Cancel',
            cancel: function () {
                // add cancel code..
            },
            buttonClicked: function (index) {
                console.dir(index);
                if (index == 0) $scope.emailProject(timesheet);
                if (index == 1) $scope.editProject(timesheet);
                if (index == 2) $scope.archiveProject(timesheet);
                return true;
            }
        });

        // For example's sake, hide the sheet after two seconds
        //$timeout(function() {
        //    hideSheet();
        //}, 2000);

    };

    $scope.archiveProject = function (project) {
        var route = 'project/archive';

        $http({
            method: 'post',
            url: baseURL + route,
            data: {'project_id': project.id},

        }).success(function (data) {

            if (data['status'] == 'success') {
                console.dir('archive toggle project - success');
                console.dir(data);


                console.dir('total projects left');
                console.dir($('#company-' + project.company.id).children('.projects').length);

                // UserService.toggleProject(project, data['project']);


                if ($('#company-'+project.company.id).children('.projects').length == 1) {
                   $('#company-'+project.company.id).slideUp("normal", function() {
                       UserService.toggleProject(project, data['project']);
                   } );
                } else {
                   $('#project-'+project.id).slideUp("normal", function() {
                       UserService.toggleProject(project, data['project']);
                   } );
                }

            } else {
                console.dir('archive project - success but error');
            }

        }).error(function (data) {
            console.dir('archive project - error');
            console.dir(data);
        });

    }


    $scope.editProject = function (project) {
        console.dir('setting project');
        console.dir(project);
        $scope.project = project;

        store.set('project', project);
        $state.go('app.project-edit', {project_id: $scope.project.id});
    };

    $scope.emailnvoice = function (project) {
        console.dir('email');
    }


})

app.controller('ProjectEditCtrl', function ($scope, $stateParams, $http, $state, store, localStorageService, $ionicModal,
                                            UserService, $ionicHistory, $ionicPopup, $ionicLoading, $translate) {
    console.dir('project edit controller');

    $scope.form = {};

    $scope.budgets = {
        0: $translate.instant('project.budget.no'),
        1: $translate.instant('project.budget.project-hours'),
        2: $translate.instant('project.budget.project-costs'),
        3: $translate.instant('project.budget.hours-task'),
        4: $translate.instant('project.budget.hours-person'),
    };
    $scope.invoicingMethods = {
        0: $translate.instant('project.invoice.not-billable'),
        1: $translate.instant('project.invoice.project'),
        2: $translate.instant('project.invoice.task'),
        3: $translate.instant('project.invoice.person'),
        4: $translate.instant('project.invoice.none'),
    };

    $scope.project = UserService.getProject($stateParams.project_id);
    $scope.companies = angular.copy(UserService.getCompanies());
    $scope.clients = angular.copy(UserService.getClients());

    // Removing archived companies from array
    $scope.companies = $.grep($scope.companies, function (company) {

        if (company.enabled) { // or whatever
            return true;
        }

        if (!$scope.project.id) return false;

        if (company.id == $scope.project.company.id) {
            return true;
        }

        return false; // keep the element in the array
    });
    // Removing archived clients from array
    $scope.clients = $.grep($scope.clients, function (client) {
        if (client.enabled) { // or whatever
            return true;
        }

        if (!$scope.project.id) return false;

        if (client.id == $scope.project.company.id) {
            return true;
        }

        return false; // keep the element in the array
    });


    // New project - preselect first company;
    if (!$scope.project.company) {
        if ($scope.companies[0]) $scope.project.company = $scope.companies[0];
        else $scope.project.company = $scope.clients[0];
        $scope.project.invoice_method = 0;
        $scope.project.budget = 0;
    }

    console.dir($scope.project);
    console.dir($scope.project.tasks);

    $scope.newTask = function () {
        var task = {'name': '', 'color': '#eee', 'billable': true, 'enabled': true};

        $scope.project.tasks.push(task)
        $scope.openTaskModal(task);

    }


    $scope.newTeam = function () {

        $ionicPopup.alert({
            title: 'Not ready yet',
            subTitle: 'Coming in a future update.',
        });
    }

    $scope.closeModal = function () {
        if($scope.companyModal) $scope.companyModal.hide();
        if($scope.modalBudget) $scope.modalBudget.hide();
        if($scope.modalInvoice) $scope.modalInvoice.hide();
        if($scope.modalTask) $scope.modalTask.hide();
        if($scope.modalTeam) $scope.modalTeam.hide();
        if($scope.modalOwner) $scope.modalOwner.hide();
    };

    $scope.closeCompanyModal = function () {
        $scope.companyModal.hide();
    };

    $scope.openCompaniesModal = function () {
        if (!$scope.modal) {
            $ionicModal.fromTemplateUrl('templates/project/_companies.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.companyModal = modal;
                $scope.companyModal.show()
            });

        } else {
            $scope.companyModal.show();
        }
    };

    $scope.openBudgetModal = function () {
        if (!$scope.modalBudget) {
            $ionicModal.fromTemplateUrl('templates/project/_budget.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.modalBudget = modal;
                $scope.modalBudget.show();
            });
        } else {
            $scope.modalBudget.show();
        }
    };
    $scope.openInvoiceModal = function () {

        if (!$scope.modalInvoice) {
            $ionicModal.fromTemplateUrl('templates/project/_invoicing_method.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.modalInvoice = modal;
                $scope.modalInvoice.show();
            });
        } else {
            $scope.modalInvoice.show();
        }
    };

    $scope.openTaskModal = function (task) {
        $scope.task = task;

        if (!$scope.taskModal) {
            $ionicModal.fromTemplateUrl('templates/project/_task.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.modalTask = modal;
                $scope.modalTask.show();
            });
        } else {
            $scope.modalTask.show();
        }
    };

    $scope.openTeamModal = function (team) {

        $scope.team = team;

        if (!$scope.modalTeam) {
            $ionicModal.fromTemplateUrl('templates/project/_team.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.modalTeam = modal;
                if (team != $scope.user)
                    $scope.modalTeam.show();
            });
        } else {
            if (team != $scope.user)
                $scope.modalTeam.show();
        }

        if (!$scope.modalOwner) {

            $ionicModal.fromTemplateUrl('templates/project/_owner.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.modalOwner = modal;
                if (team == $scope.user)
                    $scope.modalOwner.show();
            });
        } else {
            if (team == $scope.user) {
                $scope.modalOwner.show();
            }
        }


    };


    $scope.setCompany = function (company) {
        $scope.project.company = company;
        $scope.companyModal.hide();
    }

    $scope.updateProject = function (form) {

        console.dir('Updating Project');
        if (!form.$valid) {
            console.dir('invalid');
            console.dir(form);
            return false;
        }


        $ionicLoading.show({
            template: '<ion-spinner class="light"></ion-spinner><br />Saving...',
            content: '',
        });

        var employees = [];
        var emp;

        if ($scope.project.employees && $scope.project.employees.length > 1) {
            this.project.employees.forEach(function (employee) {

                // copy the var so we dont change the data the user sees
                emp = angular.copy(employee);
                emp.employee = emp.employee.id;

                employees.push(emp)
            });
        }

        console.dir(this.project.tasks);

        var formData = {
            'project': {
                id: $scope.project.id,
                'name': $scope.project.name,
                alert_value: $scope.project.alert_value,
                hourly_rate: $scope.project.hourly_rate,
                budget_amount: $scope.project.budget_amount,
                budget_hours: $scope.project.budget_hours,
                user_hourly_rate: $scope.project.user_hourly_rate,
                'company': $scope.project.company.id,
                'budget_method': $scope.project.budget,
                'invoice_method': $scope.project.invoice_method,
                'tasks': this.project.tasks,
                'employees': employees,
                color: ($scope.project.color) ? $scope.project.color : '#87CEFA'
            }
        };
        console.dir(formData);
        console.dir(this.project.tasks);

        var route = 'project';


        $http({
            method: 'post',
            url: baseURL + route,
            data: formData

        }).success(function (data) {
            console.dir(data);

            if (data.status == 'success') {
                console.dir('updating projects success');

                $scope.project = data['project'];

                UserService.setProject(data['project']);

                $ionicHistory.goBack();
                $ionicPopup.alert({
                    title: 'Project Saved!',
                });

            } else {
                console.dir('updating projects success - error');
            }

        }).error(function (data) {
            console.dir('updating projects error');
            console.dir(data);
            $ionicLoading.hide();

        }).then(function () {
            $ionicLoading.hide();
        });


    }


});