app.controller('ReportCtrl', function ($scope, $stateParams, $http, $state, ionicDatePicker, $ionicModal, UserService,
                                       $ionicLoading, $ionicPopup, localStorageService) {

    console.dir('report controller');
    $scope.date = {};
    $scope.report = {};
    $scope.user = UserService.getUser();
    $scope.report.type = 'hours';

    $scope.companies = angular.copy(UserService.getCompanies());
    $scope.clients = angular.copy(UserService.getClients());
    // $scope.companies = jQuery.merge(companies, clients);
    $scope.projects = UserService.getActiveProjects();
    $scope.projectOptions = [];
    $scope.companyOptions = [];
    $scope.report.companies = null;
    $scope.report.projects = null;
    $scope.report.tasks = null;
    $scope.all = [];
    $scope.date['start'] = new Date(moment().subtract('days', '14'));
    $scope.date['end'] = new Date();


    // employee
    var employer_companies = UserService.getEmployerCompanies();
    console.dir(employer_companies);
    // var employer_clients = UserService.getEmployerClients();
    var employer_projects = UserService.getEmployerProjects();
    // $scope.projects = jQuery.merge($scope.projects, employer_projects);
    $scope.clients = jQuery.merge($scope.clients, employer_companies);
    $scope.companies = jQuery.merge($scope.companies, employer_companies);


    // $scope.refresh = function () {
    //     var route = 'report'
    //     $http({
    //         method: 'get',
    //         url: baseURL + route,
    //         // data: report,
    //
    //     }).success(function (result) {
    //         $scope.companies = result.companies;
    //         $scope.clients = result.clients;
    //         $scope.projects = result.companies;
    //     });
    // }


    $scope.allCompanies = function () {
        $scope.report.companies = null;
        $scope.all.company = true;
    };
    $scope.allProjects = function () {
        $scope.report.projects = null;
        $scope.all.project = true;
    };
    $scope.allTasks = function () {
        $scope.report.tasks = null;
        $scope.all.task = true;
    };

    var authData = localStorageService.get('authorizationData');

    $(".select2").select2({
        allowClear: true,
        tags: true,
        tokenSeparators: [','],
        // data: tags,
        ajax: {
            headers: {
                "Authorization": 'Bearer ' + authData.token,
                "Content-Type": "application/json",
            },
            url: baseURL + 'timesheet/tags',
            dataType: 'json',
            delay: 600,
            data: function (params) {

                $('#tag-search').show();
                return {
                    q: params.term, // search term
                    page: params.page
                };


            },
            processResults: function (data, params) {
                params.page = params.page || 1;
                console.dir(data);
                $('#tag-search').hide();

                return {
                    results: data,
                    // pagination: {
                    //     more: (params.page * 30) < data.total_count
                    // }
                };
            },
            cache: true
        },
        createTag: function (tag) {
            return;
            console.dir(tag);
            if ($.trim(tag.term) == "") return;
            return {
                id: '__'+tag.term,
                text: tag.term+' (NEW)',
                tag: true
            };
        }
    });


    $scope.setTimeFrame = function (option) {
        $scope.date['end'] = new Date();

        var momentStart = 0;

        if ($scope.user.start_of_week)
            momentStart = $scope.user.start_of_week - 1;

        switch (option) {
            case 'thisweek':
                $scope.date['start'] = new Date(moment().startOf('isoWeek').add(momentStart, 'days'));
                $scope.date['end'] = new Date(moment().endOf('isoWeek').add(momentStart, 'days'));
                break;
            case 'lastweek':
                $scope.date['start'] = new Date(moment().subtract(1, 'weeks').startOf('isoWeek').add(momentStart, 'days'));
                $scope.date['end'] = new Date(moment().subtract(1, 'weeks').endOf('isoWeek').add(momentStart, 'days'));
                break;
            case 'thismonth':
                $scope.date['start'] = new Date(moment().startOf('month'));
                $scope.date['end'] = new Date(moment().endOf('month'));
                break;
            case 'lastmonth':
                $scope.date['start'] = new Date(moment().subtract(1, 'month').startOf('month'));
                $scope.date['end'] = new Date(moment().subtract(1, 'month').endOf('month'));
                break;
            case 'thisyear':
                $scope.date['start'] = new Date(moment().startOf('year'));
                $scope.date['end'] = new Date(moment().endOf('year'));
                break;
            case 'lastyear':
                $scope.date['start'] = new Date(moment().subtract(1, 'year').startOf('year'));
                $scope.date['end'] = new Date(moment().subtract(1, 'year').endOf('year'));
                break;
        }

        $scope.closeModal();
    }

    $scope.startDatePicker = function () {
        var start = {
            callback: function (val) {  //Mandatory
                console.log('start: ' + val, new Date(val));

                $scope.date.start = new Date(val);

                delete window.start;
            },
            from: null, //Optional
            to: $scope.date.end, //Optional
            inputDate: $scope.date.start,      //Optional
            mondayFirst: true,          //Optional
            // disableWeekdays: [0],       //Optional
            closeOnSelect: true,       //Optional
            templateType: 'popup'       //Optional
        };

        ionicDatePicker.openDatePicker(start);
    };
    $scope.endDatePicker = function () {

        var end = {
            callback: function (val) {  //Mandatory
                console.log('end: ' + val, new Date(val));

                $scope.date.end = new Date(val);
                delete window.end;
            },
            from: $scope.date.start, //Optional
            to: null, //Optional
            inputDate: $scope.date.end,      //Optional
            mondayFirst: true,          //Optional
            // disableWeekdays: [0],       //Optional
            closeOnSelect: true,       //Optional
            templateType: 'popup'       //Optional
        };


        ionicDatePicker.openDatePicker(end);
    };


    $scope.openCompaniesModal = function () {
        if (!$scope.modal) {
            $ionicModal.fromTemplateUrl('templates/report/_companies.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.companyModal = modal;
                $scope.companyModal.show()
            });

        } else {
            $scope.companyModal.show();
        }
    };
    $scope.openProjectsModal = function () {

        if (!$scope.companyOptions.length) {
            console.dir('companies empty');
            console.dir($scope.report.companies);
            angular.forEach($scope.report.companies, function (name, id) {
                var company = UserService.getCompany(id);
                var emp_company = UserService.getEmployerCompany(id);

                if (company.id) {
                    $scope.companyOptions.push(company);
                } else if (emp_company.id) {
                    $scope.companyOptions.push(emp_company);
                }

            });
        }

        console.dir($scope.companyOptions);


        if (!$scope.projectModal) {
            $ionicModal.fromTemplateUrl('templates/report/_projects.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.projectModal = modal;
                $scope.projectModal.show();
            });
        } else {
            $scope.projectModal.show();
        }
    };

    $scope.openTasksModal = function () {

        if (!$scope.projectOptions.length) {
            angular.forEach($scope.report.projects, function (name, id) {
                console.dir(name);
                console.dir(id);

                var project = UserService.getProject(id);
                var emp_project = UserService.getEmployerProject(id);
                console.dir(project);
                console.dir(emp_project);

                if (project.id) {
                    $scope.projectOptions.push(project);
                } else if (emp_project.id) {
                    $scope.projectOptions.push(emp_project);
                }


            });
        }


        if (!$scope.taskModal) {
            $ionicModal.fromTemplateUrl('templates/report/_tasks.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.taskModal = modal;
                $scope.taskModal.show();
            });
        } else {
            $scope.taskModal.show();
        }
    };


    $scope.closeModal = function () {
        $scope.modal.hide();
    };
    $scope.dateRange = function () {

        if (!$scope.dateRangeModal) {
            $ionicModal.fromTemplateUrl('templates/dashboard/_daterange.html', {
                scope: $scope,
                animation: 'slide-in-left'
            }).then(function (modal) {
                $scope.dateRangeModal = modal;
                $scope.dateRangeModal.show();
            });
        } else {
            $scope.dateRangeModal.show();
        }
    };


    $scope.closeModal = function () {
        if ($scope.companyModal) {
            console.dir($scope.report.companies);

            // Removing undefined companies
            angular.forEach($scope.report.companies, function (name, id) {
                if (name == undefined) delete $scope.report.companies[id];
            });

            if ($scope.report.companies && Object.keys($scope.report.companies).length == 0) {
                $scope.report.companies = null;
            }

            $scope.companyModal.hide();
        }

        if ($scope.projectModal) {

            // Removing undefined projects
            angular.forEach($scope.report.projects, function (name, id) {
                if (name == undefined) delete $scope.report.projects[id];
            });
            if ($scope.report.projects && Object.keys($scope.report.projects).length == 0) {
                $scope.report.projects = null;
            }

            $scope.projectModal.hide();
        }


        if ($scope.taskModal) {

            // Removing undefined tasks
            angular.forEach($scope.report.tasks, function (name, id) {
                if (name == undefined) delete $scope.tasks.companies[id];
            });
            if ($scope.report.tasks && Object.keys($scope.report.tasks).length == 0) {
                $scope.report.tasks = null;
            }

            $scope.taskModal.hide();
        }

        if ($scope.dateRangeModal) $scope.dateRangeModal.hide();
        $scope.viewReport.hide();
        $scope.viewExpenseReport.hide();
    };
    $scope.closeEmailModal = function () {
        $scope.emailModal.hide().then(function () {
            $scope.input.email = null;
            $scope.emailModal.remove();
            $scope.emailModal = null;
        });

    };


    $ionicModal.fromTemplateUrl('templates/report/_preview.html', {
        scope: $scope,
        animation: 'slide-in-left',
    }).then(function (modal) {
        $scope.viewReport = modal;
    });

    $ionicModal.fromTemplateUrl('templates/report/_expense.html', {
        scope: $scope,
        animation: 'slide-in-left',
    }).then(function (modal) {
        $scope.viewExpenseReport = modal;
    });


    $scope.openEmailModal = function () {
        if (!$scope.emailModal) {
            $ionicModal.fromTemplateUrl('templates/report/_email.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.emailModal = modal;
                $scope.emailModal.show();
            });
        } else {
            $scope.emailModal.show();

        }
    };


    $scope.input = {format: 'pdf'};


    $scope.$watch('report.companies', function () {
        $scope.companyOptions = [];
        $scope.report.projects = null;
        $scope.report.tasks = null;
        $scope.projectOptions = [];
    }, true);

    $scope.$watch('report.projects', function () {
        $scope.projectOptions = [];
        $scope.report.tasks = null;
    }, true);

    $scope.createReport = function (form) {

        console.dir('create report');
        console.dir($scope.report);

        var start = moment($scope.date.start).format('YYYY-MM-DD');
        var end = moment($scope.date.end).format('YYYY-MM-DD');

        var report = {};
        report.detailed_report = {};

        report.detailed_report.type = $scope.report.type;
        report.detailed_report.time_frame = start + ',' + end;
        report.detailed_report.company = [];
        report.detailed_report.project = [];
        report.detailed_report.task = [];
        report.detailed_report.tag = $('.select2').val(),


        // Building companies projects and tasks
        angular.forEach($scope.report.companies, function (name, id) {
            console.dir(id);

            if (name) {
                report.detailed_report.company.push(id);
            }
        });
        angular.forEach($scope.report.projects, function (name, id) {
            console.dir(id);

            if (name) {
                report.detailed_report.project.push(id);
            }
        });
        angular.forEach($scope.report.tasks, function (name, id) {
            console.dir(id);

            if (name) {
                report.detailed_report.task.push(id);
            }
        });


        console.dir($scope.input.email); //return;
        // Email Report
        if ($scope.input.email) {
            console.dir('email the report');
            report.email = true;
            report.cc = $scope.input.cc;
            report.format = $scope.input.format;

            $ionicLoading.show({
                template: '<ion-spinner class="light"></ion-spinner><br />Emailing Report...',
                content: '',
            });

        } else {
            // Build Report
            $ionicLoading.show({
                template: '<ion-spinner class="light"></ion-spinner><br />Building Report...',
                content: '',
            });
        }

        console.dir(report);
        var items = $.param(report);
        var route = 'report/preview'

        $http({
            method: 'get',
            url: baseURL + route + '?' + items,
            // data: report,

        }).success(function (data) {

            console.dir(data);
            $ionicLoading.hide();

            if ($scope.input.email) {
                $scope.closeEmailModal();
                $ionicPopup.alert({
                    title: 'Report has been emailed!',
                });
            } else {

                // using this instead of scope incase user clicks subit with dropdown open, it changes after the form fires and then
                // picks the wrong if statement.
                if (report.detailed_report.type == 'hours') {
                    $scope.viewReport.show();
                    $scope.total = data.report.data.total;
                    $scope.hours = data.report.hours;
                } else {
                    $scope.viewExpenseReport.show();
                    $scope.total = data.report.total;
                    $scope.expenses = data.report.expenses;


                }
            }


        }).error(function (data) {
            $ionicLoading.hide();
            console.dir('report preview error');
            console.dir(data);

            if ($scope.input.email) {
                $ionicPopup.alert({
                    title: 'Error: Unable to email report :(.',
                });
            }


        });
    }


});