app.controller('TimesheetCtrl', function ($scope, $stateParams, $http, $state, store, TimesheetService, $ionicPlatform, $ionicNavBarDelegate,
                                          QuickActionService, $rootScope, $ionicLoading) {
    console.dir('timesheet controller');

    var route = 'timesheet';
    $scope.data = store.get('timesheets');
    var option = $stateParams.option;

    $scope.timesheets = TimesheetService.getTimesheets();

    $scope.$on('reloaded', function (event, data) {
        $scope.timesheets = TimesheetService.getTimesheets();
        var reloadDone = false;

        angular.forEach($scope.timesheets, function (date) {
            // console.dir(date);
            if (!reloadDone) {

                angular.forEach(date.timesheets, function (timesheet) {
                    if (!reloadDone) {
                        console.dir(timesheet.timer_start);
                        if (timesheet.timer_start) {
                            $scope.startTimer(timesheet);
                            reloadDone = true;
                        }
                    }
                })
            }
        });
    });

    console.dir($scope.timesheets);

    $scope.done = null;

    $scope.shouldShowDelete = false;
    $scope.shouldShowReorder = false;
    $scope.listCanSwipe = true;
    $scope.timer = null;

    // $scope.$on('user:updated', function(event,data) {
    //     console.dir('timesheet REFRESH');
    //     $scope.refreshTimesheets();
    // });

    $scope.last_month = Date
    var now = new Date();
    $scope.last_month = moment(now).subtract(1, 'months').format("YYYY-MM-01");

    $scope.onClick = function (points, evt) {
        console.log(points, evt);
    };

    $rootScope.$on('timesheet:refresh', function (event) {
        console.dir('reload');
        $scope.timesheets = TimesheetService.getTimesheets();
        console.dir($scope.timesheets);
    });

    $scope.setToday = function () {
        var now = new Date();
        $scope.today = moment(now).format("YYYY-MM-DD");
    }

    $scope.load = function () {
        console.dir('loading more timeseets');

        $scope.loaded = true;
        var offset = $(".timesheet").length;

        if ($scope.refresh) {
            offset = 0;
        }


        $http({
            method: 'get',
            url: baseURL + route + '?offset=' + offset,

        }).success(function (data) {

            console.dir('load suc');
            console.dir(data);


            if ($scope.refresh) {
                console.dir('refreshed');

                // Stop running timer
                if ($scope.timer) {
                    $scope.stopTimer($scope.timer);
                }

                $scope.timesheets = data['timesheets'];
                TimesheetService.setTimesheets(data['timesheets']); // updating cache
                $scope.refresh = null;
                $scope.$apply;
            }

            angular.forEach(data['timesheets'], function (value, key) {

                if ($scope.timesheets[key]) {
                    $scope.timesheets[key] = value;
                } else {
                    $scope.timesheets[key] = {
                        'date': value.date_logged,
                        'timesheets': {}
                    };

                    $scope.timesheets[key] = value;
                }

            });

            // Start running timer on refresh
            if (data['running']) {
                console.dir(data['running']);
                $scope.startTimer(data['running']);
            }

            if (data['timesheets'].length == 0) $scope.done = true;
            //$scope.done = true;

            $ionicLoading.hide();
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.$broadcast('scroll.refreshComplete');

        }).error(function (data, status, headers, config) {
            console.dir('getting timesheets error');
            $scope.done = true;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicLoading.hide();
            $scope.$broadcast('scroll.refreshComplete');
        });
    }

    $scope.toggleTimer = function (event, t) {
        console.dir('toggle timer');
        var timesheet_id = t.id;
        console.log(timesheet_id);

        // Prevent default form
        if (event) {
            event.preventDefault();
        }

        $('.timesheet-play-' + timesheet_id).hide();
        $('.timesheet-icon-' + timesheet_id).show();

        var route = 'timesheet/toggle';

        return $http({
            method: 'post',
            url: baseURL + route,
            data: {'timesheet_id': timesheet_id},

        }).success(function (data) {
            console.log(data);


            if (data['status'] != 'success') {
                console.dir('toggle suc - error');
                return

            }

            console.dir('toggle suc');

            var timesheet = data['data']['timesheet'];

            // Stopping a running timer that isnt this one
            if (data['data']['running']) {
                console.dir('stopping dif timer');
                $scope.stopTimer(data.data.running.timesheet.currentTimer);

                var t = data['data']['running']['timesheet'];
                var d = data['data']['running']['date'];
                var pageDate = $stateParams.date;

                TimesheetService.setTimesheet(data['data']['running']['timesheet'], pageDate);
                $scope.timesheets[d]['timesheets'][t.id] = t;
            }


            if (data['data']['status'] == 'stopped') {
                $scope.stopTimer(data.data.time);
                var pageDate = $stateParams.date;
                TimesheetService.setTimesheet(data['data']['timesheet'], pageDate);

                t = data['data']['timesheet'];
            } else {
                console.dir('start timer 1');

                // ng-init will call this automatically
                $scope.startTimer(timesheet)
                TimesheetService.setTimesheet(timesheet);

            }

            var date = data['data']['date'];
            $scope.timesheets[date]['timesheets'][timesheet_id] = timesheet;


        }).error(function (data, status, headers, config) {
            console.dir('toggle error');
            $('.timesheet-icon-' + timesheet_id).hide();
            $('.timesheet-play-' + timesheet_id).show();

            // $('.timesheet-play-' + timesheet_id).removeClass('ion-loading-c');
            $scope.done = true;

        }).then(function (result) {
            $scope.timesheets = TimesheetService.getTimesheets();

            $('.timesheet-icon-' + timesheet_id).hide();
            $('.timesheet-play-' + timesheet_id).show();
            return true;
        });
    };


    // $scope.totalDateHours = [];
    //
    // angular.forEach($scope.timesheets, function (timesheet) {
    //     var total = null;
    //     angular.forEach(timesheet.timesheets, function (timesheet) {
    //         console.dir(timesheet);
    //
    //         var time = timesheet.total_time;
    //
    //         time = moment(time, 'HH:mm:ss');
    //         console.dir(time.format("hh:mm:ss"));
    //
    //         if (!total) total = time;
    //         else {
    //             total = time.add(total, 'HH:mm:ss');
    //         }
    //         console.dir(total.format("hh:mm:ss"));
    //
    //         var date = moment(timesheet.date_logged).format('YYYY-MM-DD');
    //         $scope.totalDateHours[date] = total.format("hh:mm:ss");
    //
    //     });
    //
    //
    //
    //
    // });

    // $scope.dayTotal = function (timesheets) {
    //     console.dir('day total');
    //     console.dir(timesheets);
    //
    //
    //     var total = null;
    //     angular.forEach(timesheets, function (timesheet) {
    //         var time = timesheet.total_time;
    //
    //         time = moment(time, 'HH:mm');
    //         console.dir(time);
    //
    //         if (total) total = time;
    //         else {
    //             total = time.add(total, 'HH:mm');
    //         }
    //         console.dir(total);
    //
    //         var date = moment(timesheet.date_logged).format('YYYY-MM-DD');
    //         $scope.totalDateHours[date] = total.format("hh:mm:ss");
    //
    //         console.dir(date);
    //         console.dir(total.format("hh:mm:ss"));
    //     });
    // }

    $scope.startTimer = function (timesheet) {

        console.dir('init start timer');

        console.dir(timesheet);
        console.dir(timesheet.id);
        console.dir(timesheet.currentTimer.time);

        // if ($scope.timerRunning && $scope.timerRunning.id == timesheet.id) {
        //     console.dir($scope.timerRunning);
        //     console.dir(timesheet);
        //
        //     // Updating running timer with correct time
        //     $scope.timerRunning == timesheet;
        // }

        // Stop existing timer
        // 2nd timers are automatically stopped on the backend
        if ($scope.timer != null) {
            console.dir('timer already running - lets stop it');
            $scope.stopTimer(timesheet);
        }


        var now = new Date();
        var then = timesheet.timer_start;

        var ms = moment(now).diff(moment(then));
        var d = moment.duration(ms);
        var time = d.format("hh:mm:ss");

        // timesheet.total_time = time;
        $scope.timer = new Stopwatch(timesheet.id);
        $scope.timerRunning = timesheet;

        console.dir(timesheet.currentTimer.time);
        $scope.timer.start(timesheet.currentTimer.time + ':' + timesheet.currentTimer.s);
        //$scope.timer.start(timesheet.total_time);

        console.dir('3d stop enabled');
        QuickActionService.configure('stop');

        // if (option == 'stop') {
        //     console.dir('3d stop');
        //     $scope.toggleTimer(null, timesheet);
        //     option = null;
        // }

    };


    $scope.$on('timesheet:stop', function (event, data) {
        $scope.toggleTimer(null, $scope.timerRunning);
    });

    $scope.stopTimer = function (timer) {
        console.dir('stop timer')
        if ($scope.timer != null)
            $scope.timer.stop(timer);

        $scope.timer = null;
        $scope.timerRunning = null;
        QuickActionService.configure('play');

    }

    $scope.deleteTimesheet = function (timesheet) {
        console.dir('delete timesheet');
        console.dir(timesheet);

        var date = moment(timesheet.date_logged).format('YYYY-MM-DD');
        var route = 'timesheet/' + timesheet.id;


        $http({
            method: 'delete',
            url: baseURL + route,

        }).success(function (data) {
            console.dir('del timesheets success');
            console.dir(data);

            if (data['status'] == 'success') {
                var date = moment(timesheet.date_logged).format('YYYY-MM-DD');


                if (Object.keys($scope.timesheets[date]['timesheets']).length <= 1) {
                    console.dir('remove date header');
                    $('#timesheet-' + timesheet.id).prev().slideUp();
                }

                $('#timesheet-' + timesheet.id).slideUp(400, function () {
                    // Animation complete.

                    delete $scope.timesheets[date]['timesheets'][timesheet.id];

                    // date element is empty, remove it
                    if (jQuery.isEmptyObject($scope.timesheets[date]['timesheets'])) {
                        console.dir('remove date from object');
                        console.dir(data);
                        delete $scope.timesheets[date];
                    }

                    store.set('timesheets', $scope.data);
                });

            } else {
                console.dir('del timesheets suc error');
            }


        }).error(function (data, status, headers, config) {
            console.dir('del timesheets error');

        });

    };

    $scope.refreshTimesheets = function () {
        console.dir('start refresh');
        $scope.done = null;
        $scope.refresh = true;
        $scope.setToday();
        $scope.load();

    }

    $ionicPlatform.ready(function () {
        return;
        console.dir('platform ready');

        $ionicLoading.show({
            template: '<ion-spinner class="light"></ion-spinner><br />Refreshing...',
            content: '',
        });

        $scope.refreshTimesheets();

        $rootScope.$on('quickStop', function () {
            console.dir('quick stop');
            $scope.toggleTimer(null, $scope.timerRunning);


        });
    });


});

app.controller('TimesheetMonthCtrl', function ($scope, $stateParams, $http, $state, store, TimesheetService, $ionicPlatform) {

    $scope.editTimesheet = function (timesheet) {
        console.dir('edit timesheet');

        var date = moment(timesheet.date_logged).format('YYYY-MM-DD');
        store.set('monthlyTimesheet', timesheet);

        $state.go('app.timesheet-edit', {date: date, timesheet_id: timesheet.id});
    };


    var date = $stateParams.date;
    $scope.date = moment(date).toDate();
    console.dir(date);
    $scope.loaded = false;

    $scope.loadMonthly = function () {

        console.dir('load monthly');
        var route = 'timesheet';
        $scope.timesheets = [];


        $http({
            method: 'get',
            url: baseURL + route + '?date=' + $scope.date,

        }).success(function (data) {

            console.dir('load suc');
            console.dir(data);


            var items = [];
            angular.forEach(data['timesheets'], function (value, key) {


                if (items[key]) {
                    items[key] = value;
                } else {
                    items[key] = {
                        'date': value.date_logged,
                        'timesheets': {}
                    };

                    items[key] = value;
                }

            });


            $scope.timesheets = items;
            $scope.loaded = true;

            if (data['timesheets'].length == 0) $scope.done = true;
            //$scope.done = true;

            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.$broadcast('scroll.refreshComplete');

        }).error(function (data, status, headers, config) {
            console.dir('getting timesheets error');
            $scope.done = true;

        });
    }

    $scope.refreshMonthly = function (date) {
        console.dir(date);
        $scope.date = moment(date).toDate()
        $scope.loadMonthly();
    }

    $scope.deleteTimesheet = function (timesheet) {
        console.dir('delete timesheet');
        console.dir(timesheet);

        var date = moment(timesheet.date_logged).format('YYYY-MM-DD');
        var route = 'timesheet/' + timesheet.id;


        $http({
            method: 'delete',
            url: baseURL + route,

        }).success(function (data) {
            console.dir('del timesheets success');
            console.dir(data);

            if (data['status'] == 'success') {
                var date = moment(timesheet.date_logged).format('YYYY-MM-DD');


                if (Object.keys($scope.timesheets[date]['timesheets']).length <= 1) {
                    console.dir('remove date header');
                    $('#timesheet-' + timesheet.id).prev().slideUp();
                }

                $('#timesheet-' + timesheet.id).slideUp(400, function () {
                    // Animation complete.

                    delete $scope.timesheets[date]['timesheets'][timesheet.id];

                    // date element is empty, remove it
                    if (jQuery.isEmptyObject($scope.timesheets[date]['timesheets'])) {
                        console.dir('remove date from object');
                        console.dir(data);
                        delete $scope.timesheets[date];
                    }

                });


            } else {
                console.dir('del timesheets suc error');
            }


        }).error(function (data, status, headers, config) {
            console.dir('del timesheets error');

        });

    };


})

app.controller('TimesheetEditCtrl', function ($scope, $stateParams, $http, $state, store, TimesheetService, $ionicModal, $ionicPopup, $localStorage, $rootScope,
                                              $cordovaGeolocation, $ionicHistory, UserService, $ionicLoading, ionicDatePicker, $ionicPlatform,
                                              localStorageService, ionicTimePicker) {

    console.dir('timesheet edit ctrl');
    var route = 'timesheet/edit?timesheet_id=' + $stateParams.timesheet_id;

    var large = angular.copy(UserService.getLarge());

    $scope.large = false;
    if (large && (large.employee || large.projects || large.companies || large.clients)) $scope.large = true;
    $scope.search_projects = [];


    var companies = angular.copy(UserService.getCompanies());
    var clients = angular.copy(UserService.getClients());
    $scope.companies = jQuery.merge(companies, clients);

    var timesheet = $stateParams.timesheet_id;
    var date = $stateParams.date;

    // see if we are editing a monthly timesheet
    $scope.timesheet = store.get('monthlyTimesheet');
    if (!$scope.timesheet)
        $scope.timesheet = TimesheetService.getTimesheet(date, timesheet)


    // $scope.projects = UserService.getProjects();
    $scope.projects = UserService.getActiveProjects($scope.timesheet.project);

    // Employee
    var employer_companies = UserService.getEmployerCompanies();
    var employer_projects = UserService.getEmployerProjects();
    $scope.projects = jQuery.merge($scope.projects, employer_projects);
    $scope.companies = jQuery.merge($scope.companies, employer_companies);

    console.dir($scope.companies);
    console.dir($scope.projects);


    // get existing timesheet data
    if (timesheet != 'new') {
        $scope.timesheet.date_logged = moment($scope.timesheet.date_logged).toDate()

      $scope.project = $scope.timesheet.project;
      $scope.tasks = $scope.timesheet.project.tasks;


        var time = $scope.timesheet.total_time;

        // Only parse if date object.
        if (time && Date.parse(time)) {
            time = moment($scope.timesheet.total_time).format('HH:mm');
        }

        $scope.timesheet.total_time = time;

    } else {
        // New timesheet
        $scope.tasks = [];
        console.dir('new timesheet');

        console.dir($scope.projects[0])

        if ($scope.projects.length > 0) {
            $scope.timesheet = {
                project: $scope.projects[0],
                task: $scope.projects[0].tasks[0],
                date_logged: new Date(),
                locations: []
            }
            // $scope.tasks = $scope.timesheet.project.tasks;

            $scope.project = UserService.getProject($scope.timesheet.project);
            $scope.tasks = $scope.project.tasks;


        } else {
            $scope.timesheet = {
                project: null,
                task: null,
                date_logged: new Date(),
                locations: []
            }
        }

    }

    var authData = localStorageService.get('authorizationData');



    $(".select2").select2({
        allowClear: true,
        tags: true,
        tokenSeparators: [','],
        // data: tags,
        ajax: {
            headers: {
                "Authorization": 'Bearer ' + authData.token,
                "Content-Type": "application/json",
            },
            url: baseURL + 'timesheet/tags',
            dataType: 'json',
            delay: 600,
            data: function (params) {


                $('#tag-search').show();
                return {
                    q: params.term, // search term
                    page: params.page
                };


            },
            processResults: function (data, params) {
                params.page = params.page || 1;
                console.dir(data);
                $('#tag-search').hide();

                return {
                    results: data,
                    // pagination: {
                    //     more: (params.page * 30) < data.total_count
                    // }
                };
            },
            cache: true
        },
        createTag: function (tag) {
            console.dir(tag);
            if ($.trim(tag.term) == "") return;


            if (tag.term.indexOf(' ') !== -1) { // ignore trailing spaces
                return
            }

            return {
                id: '__' + tag.term,
                text: tag.term + ' (NEW)',
                tag: true
            };
        }
    });


    $scope.projectFilter = [];
    $scope.taskFilter = [];
    $scope.locations = [];


    $scope.deleteCord = function (cord) {
        var index = $scope.timesheet.locations.indexOf(cord);
        $scope.timesheet.locations.splice(index, 1);
    }

    $scope.$on('modal.hidden', function () {
        setTimeout(function () {
            $scope.projectFilter = [];
            $scope.taskFilter = [];
        }, 500);
    });


    $scope.setProject = function (project) {
        $scope.timesheet.project = project;
        $scope.timesheet.task = $scope.timesheet.project.tasks[0];

        $scope.project = UserService.getProject($scope.timesheet.project.id);
        $scope.tasks = $scope.project.tasks;

        console.dir($scope.timesheet);
        console.dir($scope.project);
        console.dir($scope.tasks);

        $scope.openTasksModal()

    };

    $scope.setProjectFromSearch = function (project) {

        $ionicLoading.show({
            template: '<ion-spinner class="light"></ion-spinner><br />Loading tasks...',
            content: '',
        });

        var route = 'timesheet/tasks';
        $http({
            type: 'get',
            url: baseURL + route + '?project_id=' + project.id,

        }).success(function (data) {
            $ionicLoading.hide();

            let p;

            if (project.company_name) {
              let c = {name: project.company_name, id: project.company_id};
              p = {name: project.project_name, id: project.id, tasks: data.tasks, company: c};
            } else {
              p = project;
            }

            $scope.projects = p;
            $scope.tasks = data.tasks;


          $scope.timesheet.project = p;
            // $scope.timesheet.task = [];
            $scope.openTasksModal()
        });


    };


    $scope.setTask = function (task) {
        $scope.timesheet.task = task;
        $scope.taskModal.hide();

        // 1 project this modal isnt called by default
        if ($scope.projectModal) $scope.projectModal.hide();
    }


    $scope.setQuick = function (project, task) {
        console.dir(task);
        $scope.timesheet.task = task;
        $scope.timesheet.project = project;
        $scope.quickModal.hide();
    }
    $scope.openTasksModal = function () {
        if (!$scope.taskModal) {
            $ionicModal.fromTemplateUrl('templates/timesheet/_tasks.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.taskModal = modal;
                $scope.taskModal.show();
            });
        } else {
            $scope.taskModal.show();
        }
    };

    $scope.openNewProjectModal = function () {
        if (!$scope.newProjectModal) {
            $ionicModal.fromTemplateUrl('templates/timesheet/_project_new.html', {
                scope: $scope,
                animation: 'slide-in-up',
            }).then(function (modal) {
                $scope.newProjectModal = modal;
                $scope.newProjectModal.show();
            });
        } else {
            $scope.newProjectModal.show();
        }
    };

    $scope.openNewTaskModal = function () {
        if (!$scope.newTaskModal) {
            $ionicModal.fromTemplateUrl('templates/timesheet/_task_new.html', {
                scope: $scope,
                animation: 'slide-in-up',
            }).then(function (modal) {
                $scope.newTaskModal = modal;
                $scope.newTaskModal.show();
            });
        } else {
            $scope.newTaskModal.show();
        }
    };


    $scope.openQuickModal = function () {
        if (!$scope.quickModal) {
            $ionicModal.fromTemplateUrl('templates/timesheet/_quick.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.quickModal = modal;
                $scope.quickModal.show();
            });
        } else {
            $scope.quickModal.show();
        }
    };

    $scope.openLocationModal = function () {

        if (!$scope.locationModal) {
            $ionicModal.fromTemplateUrl('templates/timesheet/_locations.html', {
                scope: $scope,
                animation: 'slide-in-up',
            }).then(function (modal) {
                $scope.locationModal = modal;
                $scope.locationModal.show();
            });
        } else {
            $scope.locationModal.show();
        }
    };

    $scope.openCompanyModal = function () {
        if (!$scope.modal) {
            $ionicModal.fromTemplateUrl('templates/project/_companies.html', {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.companyModal = modal;
                $scope.companyModal.show()
            });

        } else {
            $scope.companyModal.show();
        }
    };

    $scope.setCompany = function (company) {
        $scope.timesheet.company = company;
        $scope.companyModal.hide();
    }

    $scope.newLocation = 0;
    $scope.setLocation = function () {

        var location = $scope.newLocation;

        var address = {
            address: location.formatted_address,
            lat_lng: {lat: location.geometry.location.lat(), lng: location.geometry.location.lng()},
            date_added: new Date()
        };

        $scope.timesheet.locations.push(address);
        $scope.locationModal.hide();
    }

    $scope.openDatePicker = function () {
        var date = {
            callback: function (val) {  //Mandatory
                $scope.timesheet.date_logged = new Date(val);
                delete window.date;
            },
            from: null, //Optional
            // to: $scope.date.end, //Optional
            inputDate: $scope.timesheet.date_logged,      //Optional
            mondayFirst: true,          //Optional
            // disableWeekdays: [0],       //Optional
            closeOnSelect: true,       //Optional
            templateType: 'popup',       //Optional
            showTodayButton: true,
        };

        ionicDatePicker.openDatePicker(date);
    };

    $scope.getLocation = function () {
        event.preventDefault();

        $('#loading-location').show();

        var posOptions = {timeout: 10000, enableHighAccuracy: true};

        $ionicPlatform.ready(function () {

            $cordovaGeolocation
                .getCurrentPosition(posOptions)
                .then(function (position) {
                    console.dir('location3');

                    console.dir($scope.locations);

                    var latLng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
                    $scope.latLng = latLng;

                    var geocoder = new google.maps.Geocoder;
                    geocoder.geocode({'location': latLng}, function (results, status) {
                        $('#loading-location').hide();


                        if (status === google.maps.GeocoderStatus.OK) {

                            $scope.locations = results;
                            $scope.newLocation = 0;

                            $scope.openLocationModal();

                            // loading inital map preview after modal is shown
                            $scope.$on('modal.shown', function () {
                                if ($scope.locationModal.isShown()) {
                                    $scope.mapPreview(results[0]);
                                }
                            });

                            if (!results[0]) {
                                console.dir(results);
                                window.alert('No results found');
                            }
                        } else {
                            window.alert('Geocoder failed due to: ' + status);
                        }
                    });


                }, function (err) {
                    console.dir(err);
                    window.alert('No results found');
                    $('#loading-location').hide();
                });

        })
    }

    $scope.mapPreview = function (location) {
        $scope.newLocation = location;
        $scope.loadMap(location.geometry.location, 'map-preview');
    }

    $scope.viewMap = function (cords) {

        var cords = cords.lat_lng;

        if (!$scope.modal) {
            $ionicModal.fromTemplateUrl('templates/timesheet/_map.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.modal = modal;
                $scope.modal.show();
                $scope.loadMap(cords, 'map2');
            });
        } else {
            $scope.modal.show();
            $scope.loadMap(cords, 'map2');
        }
    };
    $scope.loadMap = function (cords, container) {

        var mapOptions = {
            center: cords,
            zoom: 15,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        };

        $scope.map = new google.maps.Map(document.getElementById(container), mapOptions);

        google.maps.event.addListenerOnce($scope.map, 'idle', function () {

            var marker = new google.maps.Marker({
                map: $scope.map,
                animation: google.maps.Animation.DROP,
                position: cords
            });

            var infoWindow = new google.maps.InfoWindow({
                content: "Here I am!"
            });

            google.maps.event.addListener(marker, 'click', function () {
                infoWindow.open($scope.map, marker);
            });
        });
    };

    $scope.closeNewProjectModal = function () {
        $scope.newProjectModal.hide();
    };
    $scope.closeNewTaskModal = function () {
        $scope.newTaskModal.hide();
    };
    $scope.closeTaskModal = function () {
        $scope.taskModal.hide();
    };
    $scope.closeCompanyModal = function () {
        $scope.companyModal.hide();
    };

    $scope.closeEntriesModal = function () {
        console.dir('close 1');
        $scope.entriesModal.hide();
    };

    $scope.closeModal = function () {
        if ($scope.modal) {
            $scope.modal.hide().then(function () {
                $scope.modal.remove();
                $scope.modal = null;
            });
        }
        console.dir('close all');
        if ($scope.projectModal) $scope.projectModal.hide();
        if ($scope.taskModal) $scope.taskModal.hide();
        if ($scope.quickModal) $scope.quickModal.hide();
        if ($scope.locationModal) $scope.locationModal.hide();
        if ($scope.entriesModal) $scope.entriesModal.hide();

    };
    $scope.removeImage = function () {
        $scope.expense.image = null;
    }

    $scope.getTasks = function () {
        console.dir('getting tasks');

        // $scope.tasks = $scope.timesheet.project.tasks;

        $scope.project = UserService.getProject($scope.timesheet.project);
        $scope.tasks = $scope.project.tasks;

        // Preselect first task
        $scope.timesheet.task = $scope.tasks[0];
        return;
        ;
    }


    $scope.search = function (q) {
        console.dir(this.projectSearch);

        $('#project-search').show();

        var route = 'timesheet/projects';
        $http({
            type: 'GET',
            url: baseURL + route + '?q=' + this.projectSearch,
            // data: {q: this.projectSearch},

        }).success(function (data) {
            console.dir(data);
            $('#project-search').hide();

            $scope.searchProjects = data.projects;

        });

    };

    $scope.saveTimesheet = function (timesheet) {

        if (!timesheet.project || !timesheet.task) {
            return false;
        }


        var route = 'timesheet/edit';
        var newDate = moment($scope.timesheet.date_logged).format('YYYY-MM-DD');

        console.log($scope.timesheet.total_time);
        if ($scope.timesheet.total_time) {
            $scope.timesheet.total_time = $scope.formatTime();
        }

        var location = $scope.timesheet.locations;
        console.dir($scope.timesheet)
        console.dir(location)

        var data = {
            hour: {
                project: $scope.timesheet.project.id,
                task: $scope.timesheet.task.id,
                notes: $scope.timesheet.notes,
                // entries: angular.copy(formattedEntries),
                tags: $('.select2').val(),
                totalTime: $scope.timesheet.total_time,
                id: $scope.timesheet.id,
                locations: [location[0]],
                dateLogged: newDate,

            }
        };

        // include entries if timer isnt running
        if (!$scope.timesheet.timer_start && $scope.timesheet.entries) {
            var formattedEntries = [];

            $scope.timesheet.entries.forEach(function (entry) {
                var start = moment(entry.time_start).format('h:mma');
                var end = moment(entry.time_end).format('h:mma');

                formattedEntries.push({id: entry.id, time_start: start, time_end: end});

            });

            data.hour.entries = formattedEntries;
        }

        console.dir('saving timesheet');
        console.dir(data);

        $ionicLoading.show({
            template: '<ion-spinner class="light"></ion-spinner><br />Saving...',
            content: '',
        });


        $http({
            method: 'post',
            url: baseURL + route,
            data: data,


        }).success(function (data) {
            console.dir(data);

            if (data['status'] == 'success') {
                console.dir('edit timesheet - success');

                store.remove('monthlyTimesheet');


                // getting timesheet ID from url
                var timesheet = $stateParams.timesheet_id;
                $scope.timesheet = data['timesheet'];

                // Brand New timesheet = new object from server
                if (timesheet == 'new') {
                    var pageDate = null;

                    var time = $scope.timesheet.total_time;

                    // Only parse if date object.
                    if (time && Date.parse(time)) {
                        time = moment($scope.timesheet.total_time).format('H:mm');
                    }
                    $scope.timesheet.total_time = time;

                } else {
                    var pageDate = $stateParams.date;
                }

                if (data.running) { // updating and stopping old running
                    TimesheetService.setTimesheet(data.running, data.date_logged);
                }

                var date = moment(timesheet.date_logged).format('YYYY-MM-DD');

                $ionicPopup.alert({
                    title: 'Timesheet Saved!',
                });
                TimesheetService.setTimesheet($scope.timesheet, pageDate);

                $ionicHistory.goBack();
                // console.dir(TimesheetService.getTimesheets().length);
                // $rootScope.$apply()

                // if (TimesheetService.getTimesheets().length < 2) {
                //     console.dir('broadcast');
                $rootScope.$broadcast('timesheet:refresh');
                // }


            } else {
                console.dir('edit timesheet - success but error');
                console.dir(data);
                $ionicPopup.alert({
                    title: data.message,
                });
            }

        }).error(function (data) {
            console.dir('edit timesheet - error');
            console.dir(data);
        }).then(function () {
            $ionicLoading.hide();
        });

    }

    $scope.saveButton = true;


    $scope.$watch('timesheet.total_time', function () {
        $scope.saveButton = true;

        time = $scope.timesheet.total_time;
        // Share plugin fixed
        // apple https export letter done
        // App description update
        console.log($scope.timesheet.total_time);
        if (!time || time === true) return;
        tmp = time.split(':');

        if (!tmp[1]) return;

        // sometimes minutes is 1 digit hh:m but .val() is correct. wtf
        if (tmp[1].length == 1) {
            tmp = $('#total-time').val().split(':');
            $scope.timesheet.total_time = $('#total-time').val();
        }

        // bug in input masks. minutes can be 3 characters rarely
        if (tmp[1].length == 3) {
            tmp[1] = tmp[1].substring(0, 2, -1);
        }


        if (tmp[1] >= 60) {
            $scope.saveButton = false;
        } else {
            $scope.saveButton = true;
        }


        // hours over minutes under
        if (tmp[0] > 23) {
            if (tmp[1] > 59) tmp[1] = 59;
            $scope.timesheet.total_time = "23:" + tmp[1] + "0";
            $scope.saveButton = true;
        }

    }, true);


    $scope.formatTime = function () {
        time = $scope.timesheet.total_time;
        time = $('#total-time').val();

        if (!time) return $scope.timesheet.total_time;
        tmp = time.split(':');

        if (!tmp[1]) return time;
        if (tmp[1] >= 60) return tmp[0] + ':59';

        return time;

    }

    // fires only when there's no :
    $('body').on('change', '.totalTime', function (event) {
        var time = $(this).val();
        console.dir(time);
        if (time == "") {
            return false;
        }

        tmp = time.split(':');

        if (tmp.length == 2) {
            time = moment().startOf('day').add(tmp[0], 'hours').add(tmp[1], 'minutes').format('H:mm');
        } else {
            time = moment().startOf('day').add(time, 'minutes').format('H:mm');
        }

        $scope.saveButton = true;

        $scope.timesheet.time = time;
        $(this).val(time);
    });


    $scope.openProjectsModal = function () {

        if (!$scope.large) url = 'templates/timesheet/_projects.html';
        else url = 'templates/timesheet/_project_search.html';

        if ($scope.timesheet.project)
            $scope.searchProjects = [$scope.timesheet.project];
        else
            $scope.searchProjects = [];

        if (!$scope.projectModal) {
            $ionicModal.fromTemplateUrl(url, {
                scope: $scope,
                animation: 'slide-in-left',
            }).then(function (modal) {
                $scope.projectModal = modal;
                $scope.projectModal.show();
            });
        } else {
            $scope.projectModal.show();
        }
    };

    $scope.openEntriesModal = function () {

        if ($scope.timesheet.entries) {
            $scope.entries = angular.copy($scope.timesheet.entries);
        } else {
            $scope.entries = [];
        }
        $scope.totalTime = angular.copy($scope.timesheet.totalTime);

        console.dir($scope.entries);

        $scope.updateEntryTime();

        console.dir($scope.totalTime);

        if (!$scope.entriesModal) {
            $ionicModal.fromTemplateUrl('templates/timesheet/_entries.html', {
                scope: $scope,
                animation: 'slide-in-left',
                backdropClickToClose: false, // https://github.com/ionic-team/ionic-v1/issues/162
            }).then(function (modal) {
                $scope.entriesModal = modal;
                $scope.entriesModal.show();
            });
        } else {
            $scope.entriesModal.show();
        }
    };

    $scope.saveEntries = function () {

        $scope.timesheet.entries = $scope.entries;
        $scope.timesheet.total_time = $scope.totalTime;

        console.dir($scope.timesheet.entries);
        $scope.entriesModal.hide();
    }
    $scope.deleteEntry = function (entry) {
        console.dir('remove');
        var index = $scope.entries.indexOf(entry);
        $scope.entries.splice(index, 1);
        $scope.updateEntryTime();
    };


    $scope.timePicker = function (entry, type) {

        if (type == 'start') {
            id = entry.time_start;
        } else {
            id = entry.time_end;
        }

        var date = new moment(id)
        var seconds = date.format('H') * 60 * 60 + date.format('m') * 60
        console.dir(date.format());

        var settings = {
            callback: function (val) {      //Mandatory
                if (typeof (val) === 'undefined') {
                    console.log('Time not selected');
                } else {

                    console.dir(val);

                    // var date = moment(timesheet.date_logged).format('YYYY-MM-DD');
                    var newTime = moment(entry.time_start).startOf('day').seconds(val).format();


                    // Maintaining the date part
                    if (type != 'start') {

                        var date = new moment(entry.time_start)
                        var startSeconds = date.format('H') * 60 * 60 + date.format('m') * 60
                        console.dir(val>startSeconds);
                        console.dir(val);
                        console.dir(startSeconds);


                        if (startSeconds > val) {
                            console.dir('end next day')
                            var newTime = moment(entry.time_start).startOf('day').seconds(val).add(1, 'day').format();

                        }

                    }

                    console.dir(newTime);

                    if (type == 'start') {
                        entry.time_start = newTime;
                    } else {
                        entry.time_end = newTime;
                    }

                    $scope.updateEntryTime();
                }
            },
            inputTime: seconds,   //Optional
            format: 12,         //Optional
            step: 1,           //Optional
            setLabel: 'Set'    //Optional
        };


        ionicTimePicker.openTimePicker(settings);

    }

    $scope.newEntry = function () {

        var date = new Date();
        var entry = {'time_start': date, 'time_end': date};

        $scope.entries.push(entry);
    }

    $scope.entryError = false;
        $scope.updateEntryTime = function () {

        var seconds = 0;

        $scope.entries.forEach(function (entry) {
            var start = moment(entry.time_start);
            var end = moment(entry.time_end);

            seconds = seconds + end.diff(start, 'seconds');
        });

        // var date = moment(timesheet.date_logged).format('YYYY-MM-DD');
        var total = moment().startOf('day').seconds(seconds).format('H:mm');

        if (seconds >= 86400) {
            $scope.entryError = "Invalid Time - You cannot work more than 24 hours in a day";
        } else {
            $scope.entryError = false;
            $scope.totalTime = total;
        }

    };


    if (timesheet == 'new') {
        if ($scope.projects.length > 1 || ($scope.projects.length.length > 0 && $scope.projects[0].tasks.length > 1) || $scope.large == true) {
            $scope.openProjectsModal()
        }
    }


});

app.filter('orderByKey', ['$filter', function ($filter) {
    return function (items, field, reverse) {

        var keys = $filter('orderBy')(Object.keys(items), field, reverse),
            obj = {};
        keys.forEach(function (key) {
            obj[key] = items[key];
        });
        return obj;
    };

}]);
