// http://stackoverflow.com/questions/20318822/how-to-create-a-stopwatch-using-javascript

//(function($) {
var Stopwatch = function (elem, options, offset) {

    var timer = createTimer(),
        startButton = createButton("start", start),
        stopButton = createButton("stop", stop),
        resetButton = createButton("reset", reset),
        offset = offset || 0,
        clock,
        interval;

    // default options
    options = options || {};
    delay = 1000;

    // append elements
    //elem.appendChild(startButton);
    //elem.appendChild(stopButton);
    //elem.appendChild(resetButton);

    // initialize
    //reset();

    //if (options == 'start') start();
    if (options == 'stop') {
        stop();

        //<span ng-bind="timesheet.current_timer.s"></span>
    }

    // private functions
    function createTimer() {
        return document.createElement("span");
    }

    function createButton(action, handler) {
        var a = document.createElement("a");
        a.href = "#" + action;
        a.innerHTML = action;
        a.addEventListener("click", function (event) {
            handler();
            event.preventDefault();
        });
        return a;
    }

    function start(startTime) {
        if (!interval) {

            // Adding initial time to the clock

            var time = TimeToSeconds(startTime);
            clock = time * 1000;

            offset = Date.now();
            interval = setInterval(update, delay);

            setTimeout(function () {
                $('#timesheet-time-'+elem+'-time').hide();
                $('#timesheet-time-'+elem+'-timer').show();
            }, 1000);
        }
    }


    function stop(timer) {
        if (interval) {
            clearInterval(interval);
            interval = null;
        }

        // No timer.time on refresh
        if (!timer.time) return;

        setTimeout(function () {
            $('#timesheet-time-'+elem+'-time').show();
            $('#timesheet-time-'+elem+'-timer').hide();
        }, 1000);

        $('#timesheet-time-'+elem+'-timer').html(timer.time+'<span class="seconds">:'+timer.s+'</span>');

    }

    function reset() {

        //var time = TimeToSeconds(offset+':00');
        //clock = time * 1000;
        clock = 0 //offset * 1000; //offset the milliseconds
        //render();
    }

    function update() {
        clock += delta();
        render();
    }

    function render() {

        //var time = moment().hour(0).minute(0).second(counter++).format('HH : mm : ss');
        var time =  moment.duration(clock / 1000, 'seconds').format('H:mm', {trim: false});
        var seconds = moment().hour(0).minute(0).second(clock / 1000).format(':ss');

        $(document).prop('title', time + seconds + ' | LogMyHours.com');
        $(elem).html(time+'<small><small>'+seconds+'</small></small>');
        $('#timesheet-time-'+elem+'-timer').html(time+'<small><small>'+seconds+'</small></small>');
    }

    function delta() {
        var now = Date.now(),
            d = now - offset;

        offset = now;
        return d;
    }


    function TimeToSeconds(str) {
        var p = str.split(':'),
            s = 0, m = 1;

        while (p.length > 0) {
            s += m * parseInt(p.pop(), 10);
            m *= 60;
        }

        return s;
    }

    // public API
    this.start = start;
    this.stop = stop;
    this.reset = reset;
};
//
//$.fn.stopwatch = function(options, offset) {
//    return this.each(function(idx, elem) {
//        new Stopwatch(elem, options, offset);
//    });
//};
//})(jQuery);