angular.module('starter').factory('QuickActionService', ['$rootScope', '$q', '$state', '$ionicHistory', QuickActionService]);

function QuickActionService($rootScope, $q, $state, $ionicHistory, $scope) {

    $rootScope.$on('quickStart', function () {
        $state.go('app.timesheet').then(function () {
            $state.go('app.timesheet-quick', {timesheet_id: 'new'});
        });
    });

    $rootScope.$on('quickStop', function () {
        $state.go('app.timesheet', {option: 'stop'}).then(function () {
            $rootScope.$broadcast('timesheet:stop');
        });

    });

    // $rootScope.$on('quickInvoice', function () {
    //     $state.go('app.invoice.active').then(function () {
    //         $state.go('app.invoice-edit.items', {invoice_id: 'new'});
    //     });
    //
    // });

    $rootScope.$on('quickExpense', function () {
        $state.go('app.expense').then(function () {
            $state.go('app.expense-edit', {expense_id: 'new', option: 'camera'});
        });
    });

    function check3DTouchAvailability() {
        return $q(function (resolve, reject) {
            if (window.ThreeDeeTouch) {
                window.ThreeDeeTouch.isAvailable(function (available) {
                    resolve(available);
                });
            } else {
                reject();
            }
        });
    }

    function configure(mode) {
        // Check if 3D Touch is supported on the device
        check3DTouchAvailability().then(function (available) {

            if (available) {    // Comment out this check if testing in simulator

                console.dir('setting up 3d');
                console.dir(window.ThreeDeeTouch);


                if (mode == 'play') {
                    var play = {
                        type: 'quickStart',
                        title: 'New Timer',
                        subtitle: '',
                        iconType: 'play'
                    }
                } else {
                    var play = {
                        type: 'quickStop',
                        title: 'Stop Timer',
                        subtitle: '',
                        iconType: 'pause'
                    }
                }

                // Configure Quick Actions
                window.ThreeDeeTouch.configureQuickActions([
                    {
                        type: 'quickExpense',
                        title: 'Capture Receipt',
                        subtitle: '',
                        iconType: 'CapturePhoto'
                    },
                    // {
                    //     type: 'quickInvoice',
                    //     title: 'Create Invoice',
                    //     subtitle: '',
                    //     iconType: 'Composer'
                    // },
                    play
                ]);

                // Set event handler to check which Quick Action was pressed
                window.ThreeDeeTouch.onHomeIconPressed = function (payload) {
                    $rootScope.$broadcast(payload.type);
                };
            }
        })
    }


    return {
        configure: configure,
    };
}