// https://github.com/gsklee/ngStorage

app.service('UserService', function ($filter, $localStorage, $ionicPopup, $ionicLoading) {

    var setAll = function (data) {
        setClients(data['data']['clients']);
        setCompanies(data['data']['companies']);
        setExpenses(data['data']['expenses']);
        setExpenseCategories(data['data']['expense_categories']);
        setInvoices(data['data']['invoices']);
        setEmployees(data['data']['employees']);
        setProjects(data['data']['projects']);
        setEmployerProjects(data['data']['employer_projects']);
        setEmployerCompanies(data['data']['employer_companies']);
        setUser(data['user']);
        setData(data['data']);
        setTags(data['tags']);
    };

    var setUser = function (user) {
        $localStorage.user = user;
    };

    var getUser = function () {
        return $localStorage.user;
    };

    var setData = function (data) {
        $localStorage.data = data;
    };

    var getData = function () {
        return $localStorage.data;
    };
    var getLarge = function () {
        return $localStorage.data['large'];
    };

    var setTags = function (tags) {
        $localStorage.tags = tags;
    };

    var setTag = function (tag) {
        var tags = getTags();
        var item = $filter('filter')(tags, {id: parseInt(tag.id)}, true)[0];

        if (item) {
            angular.copy(tag, item);
        } else {
            tags.push(tag);
        }

        setTags(tags);
    };
    var getTags = function () {

        return ($localStorage.tags || [] );
    };
    var getTag = function (id) {

        var tags = getTags();
        var item = $filter('filter')(tags, {id: parseInt(id)}, true)[0];
        return (angular.copy(item) || {});

    };

    var setClients = function (clients) {
        $localStorage.clients = clients;
    };

    var setClient = function (client) {
        var clients = getClients();
        var item = $filter('filter')(clients, {id: parseInt(client.id)}, true)[0];

        if (item) {
            angular.copy(client, item);
        } else {
            clients.push(client);
        }

        setClients(clients);
    };

    var getClients = function () {

        return ($localStorage.clients || [] );
    };
    var getClient = function (id) {

        var clients = getClients();
        var item = $filter('filter')(clients, {id: parseInt(id)}, true)[0];
        return (angular.copy(item) || {});

    };


    var setCompanies = function (companies) {
        $localStorage.companies = companies;
    };

    var setCompany = function (company) {
        var companies = getCompanies();
        var item = $filter('filter')(companies, {id: parseInt(company.id)}, true)[0];

        if (item) {
            angular.copy(company, item);
        } else {
            companies.push(company);
        }

        setCompanies(companies);

    };

    var getCompanies = function () {

        return ($localStorage.companies || [] );
    };
    var getCompany = function (id) {

        var companies = getCompanies();
        var item = $filter('filter')(companies, {id: parseInt(id)}, true)[0];

        return (angular.copy(item) || {});

    };


    var setEmployerCompanies = function (companies) {
        $localStorage.employer_companies = companies;
    };

    var getEmployerCompanies = function () {

        return ($localStorage.employer_companies || [] );
    };
    var getEmployerCompany = function (id) {

        var companies = getEmployerCompanies();
        var item = $filter('filter')(companies, {id: parseInt(id)}, true)[0];

        return (angular.copy(item) || {});

    };

    var setEmployerProjects = function (projects) {
        $localStorage.employer_projects = projects;
    };


    var setExpenses = function (expenses) {
        // store.set('expenses', expenses);
        $localStorage.expenses = expenses;
    };
    var setExpense = function (expense) {
        var expenses = getExpenses();
        var item = $filter('filter')(expenses, {id: parseInt(expense.id)}, true)[0];

        if (item) {
            angular.copy(expense, item);
        } else {
            expenses.push(expense);
        }

        setExpenses(expenses)

    };
    var getExpenses = function () {
        return ($localStorage.expenses || [] );
        // return (store.get('expenses') || [] );
    };
    var getExpense = function (id) {
        var expenses = getExpenses();
        var item = $filter('filter')(expenses, {id: parseInt(id)}, true)[0];

        return (angular.copy(item) || {});
    };

    var getExpenseCategories = function () {
        return ($localStorage.expense_categories || [] );
    };
    var setExpenseCategories = function (expense_categories) {
        $localStorage.expense_categories = expense_categories;
    };
    var setExpenseCategory = function (expense_category) {
        var expenseCategories = getExpenseCategories();
        var item = $filter('filter')(expenseCategories, {id: parseInt(expense_category.id)}, true)[0];

        if (item) {
            angular.copy(expense_category, item);
        } else {
            expenseCategories.push(expense_category);
        }

        setExpenseCategories(expenseCategories)

    };


    var setInvoices = function (invoices) {
        $localStorage.invoices = invoices;
        // store.set('invoices', invoices);
    };
    var setInvoice = function (invoice) {
        // var invoices = getInvoices();
        // invoices[invoice.id] = invoice;
        // $localStorage
        // store.set('invoice', getInvoices());
    };
    var getInvoices = function () {
        return ($localStorage.invoices || [] );
        // return (store.get('invoices') || [] );
    };
    var getInvoice = function (id) {

        var invoices = getInvoices();

        console.dir(invoices);
        console.dir(invoices);
        console.dir(getProjects());

        var item = $filter('filter')(invoices['active'], {id: parseInt(id)}, true)[0];

        if (!item) {
            item = $filter('filter')(invoices['archived'], {id: parseInt(id)}, true)[0];
        }
        console.dir(item);

        return (angular.copy(item) || {});

    };

    var setEmployees = function (employees) {
        $localStorage.employees = employees;
        // store.set('employees', employees);
    };
    var setEmployee = function (employee) {
        // var employees = getEmployees();
        // employees[employee.id] = employee;
        // $localStorage
        // store.set('employee', getEmployees());
    };
    var getEmployees = function () {
        return ($localStorage.employees || [] );
        // return (store.get('employees') || [] );
    };
    var getEmployee = function (id) {

        var employees = getEmployees();

        console.dir(employees);
        console.dir(employees);
        console.dir(getProjects());

        var item = $filter('filter')(employees['active'], {id: parseInt(id)}, true)[0];

        if (!item) {
            item = $filter('filter')(employees['archived'], {id: parseInt(id)}, true)[0];
        }
        console.dir(item);

        return (angular.copy(item) || {});

    };

    var setProjects = function (projects) {
        $localStorage.projects = projects;
    };

    var toggleProject = function (oldProject, newProject) {
        var projects = getProjects();

        (oldProject.enabled == true) ? status = 'active' : status = 'archived';

        var index = projects[status].indexOf(oldProject);

        // Remove old project data from array
        projects[status].splice(index, 1);


        // Updated Project
        (newProject.enabled == true) ? status = 'active' : status = 'archived';
        projects[status].push(newProject);

        setProjects(projects);

    }

    var getEmployerProjects = function () {

        if ($localStorage.employer_projects)
            return $localStorage.employer_projects

        return ($localStorage.employer_projects || [] );
        // return (store.get('projects') || [] );
    };

    var setEmployerProject = function (project) {
        var projects = getEmployerProjects();

        var status;
        (project.enabled == true) ? status = 'active' : status = 'archived';

        console.dir(status);
        if (projects.length > 0) {
            var item = $filter('filter')(projects[status], {id: parseInt(project.id)}, true)[0];

            if (item) {
                angular.copy(project, item);
            } else {
                projects[status].push(project);
            }
        } else {
            projects[status] = [project];
        }


        setEmployerProjects(projects);
    };

    var getEmployerProject = function (id) {
        var projects = getEmployerProjects();

        // var item = $filter('filter')(projects['active'], {id: parseInt(id)}, true);
        var item = $filter('filter')(projects, {id: parseInt(id)}, true)[0];

        console.dir(id);
        console.dir(projects);
        console.dir(item);

        // if (!item) {
        //     item = $filter('filter')(projects['archived'], {id: parseInt(id)}, true)[0];
        // }

        // var tasks = {};
        // tasks['name'] = 'General';
        // tasks['color'] = '#dddddd';
        // tasks['active'] = true;
        // tasks['billable'] = true;

        return (angular.copy(item));
    };


    var setProject = function (project) {
        var projects = getProjects();

        console.dir('project data');
        console.dir(projects);
        var status;
        (project.enabled == true) ? status = 'active' : status = 'archived';

        console.dir(status);
        if (projects[status].length > 0) {
            var item = $filter('filter')(projects[status], {id: parseInt(project.id)}, true)[0];

            if (item) {
                angular.copy(project, item);
            } else {
                projects[status].push(project);
            }
        } else {
            projects[status] = [project];
        }

        console.dir(projects);
        return;

        setProjects(projects);
    };
    var getProjects = function () {

        if ($localStorage.projects)
            return $localStorage.projects

        return ($localStorage.projects || [] );
        // return (store.get('projects') || [] );
    };
    var getProject = function (id) {
        var projects = getProjects();

        var item = $filter('filter')(projects['active'], {id: parseInt(id)}, true)[0];

        if (!item) {
            item = $filter('filter')(projects['archived'], {id: parseInt(id)}, true)[0];
        }

      if (!item) {
        var projects = getEmployerProjects();
        item = $filter('filter')(projects, {id: parseInt(id)}, true)[0];
      }

        var tasks = {};
        tasks['name'] = 'General';
        tasks['color'] = '#dddddd';
        tasks['enabled'] = true;
        tasks['billable'] = true;

        return (angular.copy(item) || {'tasks': [tasks]});
    };

    // select project returned even if disabled. Returns array of projects
    var getActiveProjects = function (selectedProject) {

        var projects = angular.copy(getProjects().active);
        var projects2 = angular.copy(getProjects().archived);

        console.dir(projects);
        console.dir(projects2);

        if (!projects && !projects2) return null;
        if (projects && !projects2) return projects;
        if (!projects && projects2) return projects2;

        var allProjects = jQuery.merge(projects, projects2);

        return projects = $.grep(allProjects, function (project) {

            if (project.enabled) { // or whatever
                return true;
            }
            if (!selectedProject) return false;

            if (project.id == selectedProject.id) {
                return true;
            }

            return false; // keep the element in the array
        });

    };

    var displayNotification = function () {
        var push = new Ionic.Push({
            "onNotification": function (notification) {
                var payload = notification.payload;
                console.log(notification, payload);

                console.dir(payload);
                console.dir(notification);
                console.dir(notification.message);
                console.dir(notification.title);

                $ionicPopup.alert({
                    title: notification.title,
                    template: notification.text
                });

            },
        });
    };

    var getTimezones = function () {

        if ($localStorage.data && $localStorage.data.timezones)
            return $localStorage.data.timezones

        return [];
        // return (store.get('projects') || [] );
    };

    var enableNotifications = function () {

        var push = new Ionic.Push({
            ios: {
                alert: true,
                badge: true,
                sound: true
            },

            "onNotification": function (notification) {
                var payload = notification.payload;

                $ionicPopup.alert({
                    title: notification.title,
                    template: notification.text
                });

            },
        });

        push.register(function (token) {

            $ionicLoading.show({
                template: '<ion-spinner class="light"></ion-spinner><br />Enabling...',
                content: '',
            });


            push.saveToken(token);  // persist the token in the Ionic Platform

            PushNotification.hasPermission(function (data) {

                console.dir(data);
                if (data.isEnabled) {
                    push.saveToken(token);  // persist the token in the Ionic Platform

                    $ionicLoading.hide();

                    $ionicPopup.alert({
                        title: 'Push Notifications Enabled'
                    });

                } else {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: 'Error',
                        subTitle: 'Please enable notifications in your phone\'s settings',
                    });
                }
            });

        });
    };


    return {
        getUser: getUser,
        setUser: setUser,
        getData: getData,
        setData: setData,
        getLarge: getLarge,

        setClients: setClients,
        getClients: getClients,
        getClient: getClient,
        setClient: setClient,

        setTags: setTags,
        getTags: getTags,
        getTag: getTag,
        setTag: setTag,

        getEmployerCompanies: getEmployerCompanies,
        getEmployerCompany: getEmployerCompany,
        setEmployerCompanies: setEmployerCompanies,
        getEmployerProjects: getEmployerProjects,
        getEmployerProject: getEmployerProject,
        setEmployerProjects: setEmployerProjects,


        setCompanies: setCompanies,
        getCompanies: getCompanies,
        getCompany: getCompany,
        setCompany: setCompany,


        setExpenses: setExpenses,
        getExpenses: getExpenses,
        getExpense: getExpense,
        setExpense: setExpense,

        getExpenseCategories: getExpenseCategories,
        setExpenseCategories: setExpenseCategories,
        setExpenseCategory: setExpenseCategory,

        setInvoices: setInvoices,
        getInvoices: getInvoices,
        getInvoice: getInvoice,
        setInvoice: setInvoice,

        setEmployees: setEmployees,
        getEmployees: getEmployees,
        getEmployee: getEmployee,
        setEmployee: setEmployee,

        setProjects: setProjects,
        getProjects: getProjects,
        getActiveProjects: getActiveProjects,
        toggleProject: toggleProject,
        getProject: getProject,
        setProject: setProject,

        enableNotifications: enableNotifications,
        displayNotification: displayNotification,

        getTimezones: getTimezones,

        setAll: setAll,


    };
});


app.service('TimesheetService', function (store, $localStorage, $filter) {


    var setTimesheets = function (timesheets) {
        $localStorage.timesheets = timesheets
    };

    var setTimesheet = function (timesheet, pageDate) {
        var timesheets = getTimesheets();
        var date = moment(timesheet.date_logged).format('YYYY-MM-DD');
        // var item = $filter('filter')(timesheets, {id: parseInt(timesheet.id)}, true)[0];

        // Checking to see if we are editing a timesheet and the date changed.
        if (pageDate && timesheet.id && date != pageDate) {
            var oldTimesheet = timesheets[pageDate]['timesheets'][timesheet.id];

            delete timesheets[pageDate]['timesheets'][timesheet.id];

            // date element is empty, remove it
            if (jQuery.isEmptyObject(timesheets[pageDate]['timesheets'])) {
                console.dir('remove date from object');
                delete timesheets[pageDate];
            }
        }

        // New Timesheet Data element
        if (!timesheets[date]) {
            console.dir('new timesheet (row) data');
            timesheets[date] = {
                timesheets: {},
                date: timesheet.date_logged
            }
        }

        // pushing new item to front of array
        // if (!timesheets[date]['timesheets'][timesheet.id]) {
        //     var item = [];
        //     item[timesheet.id] = timesheet;
        //     console.dir(timesheets[date]);
        //     timesheets[date]['timesheets'].prototype.unshift(item);
        // } else {
        timesheets[date]['timesheets'][timesheet.id] = timesheet;
        // }

        console.dir(timesheets);

        $localStorage.timesheets = timesheets;
        // store.set('timesheets', timesheets);
    };
    var getTimesheets = function () {

        // var array = $.map($localStorage.timesheets, function(value, index) {
        //     return [value];
        // });
        // return array;
        if (angular.isArray($localStorage.timesheets)) return {};
        // return {};

        return $localStorage.timesheets || {};
    };
    var getTimesheet = function (date, id) {

        if (id == 'new') return [];

        try {
            timesheet = $localStorage.timesheets[date]['timesheets'][id];
        }
        catch (error) {
            console.dir(error);
            return [];
        }

        return (angular.copy(timesheet));
    };

    return {
        setTimesheets: setTimesheets,
        getTimesheets: getTimesheets,
        getTimesheet: getTimesheet,
        setTimesheet: setTimesheet,
    };
});
